-----------------------------
-- Dr. Azzy's Merc/Homun AI
-- Written by Dr. Azzy of iRO Loki
-- This AI is intended for use on official servers only
-- Permission granted to distribute in unmodified form
-- Please contact me via the iRO Forums if you're making modifications
-- so that we can work together to extend and improve this AI.
-- You may expand the AI freely through the M_Extra and H_Extra files
MainVersion="1.41 test"
-----------------------------
-- require statements handled by AI_M and AI, because the variables
-- need to be defined to process the config and tactics files.
-----------------------------
-----------------------------
-- state
-----------------------------
IDLE_ST					= 0
FOLLOW_ST				= 1
CHASE_ST				= 2
ATTACK_ST				= 3
MOVE_CMD_ST				= 4
STOP_CMD_ST				= 5 -- Not used
ATTACK_OBJECT_CMD_ST			= 6
ATTACK_AREA_CMD_ST			= 7
PATROL_CMD_ST				= 8 -- Not used
HOLD_CMD_ST				= 9 -- Not used
SKILL_OBJECT_CMD_ST			= 10
SKILL_AREA_CMD_ST			= 11
FOLLOW_CMD_ST				= 12
RANDWALK_ST				= 100
ORBITWALK_ST				= 101
REST_ST					= 102
TANKCHASE_ST				= 103
TANK_ST					= 104
PROVOKE_ST				= 105 -- Not used
FRIEND_CROSS_ST				= 106
FRIEND_CIRCLE_ST			= 107	
MOVE_CMD_HOLD_ST			= 108
----------------------------

------------------------------------------
-- global variable
------------------------------------------
LastAITime			= 0
MyState				= IDLE_ST
MyEnemy				= 0
MyDestX				= 0
MyDestY				= 0
MyMoveX				= 0
MyMoveY				= 0
MyPatrolX			= 0	--Not used
MyPatrolY			= 0	--Not used
ResCmdList			= List.new()
MyID				= 0
MySkill				= 0
MySkillLevel			= 0
MyPosX				= {0,0,0,0,0,0,0,0,0,0}	-- list of positions
MyPosY				= {0,0,0,0,0,0,0,0,0,0}	-- to better sense motion
OwnerPosX			= {0,0,0,0,0,0,0,0,0,0}	-- list of owner positions
OwnerPosY			= {0,0,0,0,0,0,0,0,0,0}	-- to better sense motion
EnemyPosX			= {0,0,0,0,0,0,0,0,0,0}
EnemyPosY			= {0,0,0,0,0,0,0,0,0,0}
MyMotions			= {0,0,0,0,0,0,0,0,0,0} -- to better detect freezes
MyStates			= {0,0,0,0,0,0,0,0,0,0}
RandomMoveTries			= 0
--Autoskill timeout counters
QuickenTimeout			= 0
GuardTimeout			= 0
MagTimeout			= 0
SightTimeout			= 0
SOffensiveTimeout		= 0
SDefensiveTimeout		= 0
SOwnerBuffTimeout		= 0
SkillTimeout			= 0
ProvokeOwnerTimeout		= 0
ProvokeSelfTimeout		= 0
SacrificeTimeout		= 0
AutoSkillTimeout		= 0 --Cast time + delay timeout
AutoSkillCastTimeout	= 0 --Cast time timeout
AutoSkillCooldown		= {}
AutoSkillCooldown[HFLI_MOON]=0
AutoSkillCooldown[HVAN_CAPRICE]=0
AutoSkillCooldown[HVAN_CHAOTIC]=0
AutoSkillCooldown[HLIF_HEAL]=0
AutoSkillCooldown[MH_POISON_MIST]=0
AutoSkillCooldown[MH_LAVA_SLIDE]=0
TankHitTimeout			= 0
SkillObjectCMDTimeout   = 0
--Advanced movement stuff
OrbitWalkStep			= 0
OrbitWalkTries			= 0
RouteWalkStep			= nil
RouteWalkDirection		= 1
KiteDestX			= 0
KiteDestY			= 0
--Other stuff
MyStart				= GetTick()
MySkillUsedCount		= 0
ChaseGiveUpCount		= 0
AttackGiveUpCount		= 0
ChaseDebuffUsed			= 0
Unreachable			= {}
FollowTryCount			= 0
FastChangeCount			= 0
MyAttackStanceX,MyAttackStanceY = 0,0
AttackDebuffUsed		= 0
NeedToDoAutoFriend		= 0
ShouldStandby			= 0
BypassKSProtect			= 0
MercType			= 0
BerzerkMode			= 0
ReturnToMoveHold		= 0
TankMonsterCount		= 0
ReturnToState			= 0
NewFriendX,NewFriendY		= 0,0
FriendMotionTime		= 0
FriendCircleIter		= 0
FriendCircleTimeout		= 0
DoneInit			= 0
AtkPosbugFixTimeout		= 0

-- These need to be globals
Actors				= {}
Players				= {}
Monsters			= {}
Targets				= {}
Summons				= {}
Retainers			= {}
IsActive			= {}
Attackers			= {} --to deal with shit that doesn't properly 
------------------------------------------


-----------Config checking----------------

function doInit(myid)
	if (UseRandWalk==1 and UseOrbitWalk==1) then
		UseOrbitWalk=0
	end
	
	if (UseAutoSkill==0 and UseSkillOnly==1) then
		UseSkillOnly = 0
	end
	if GetV(V_SKILLATTACKRANGE,myid,HVAN_CAPRICE) > 1 then -- it was a vani
		OldHomunType=VANILMIRTH
	end
	if GetV(V_SKILLATTACKRANGE,myid,MH_ERASER_CUTTER) == 1 then
			UseEriaEraseCutter=0
	end
	if GetV(V_SKILLATTACKRANGE,myid,MH_XENO_SLASHER) == 1 then -- 
			UseEriaXenoSlasher=0
	end
	if GetV(V_SKILLATTACKRANGE,myid,MH_STAHL_HORN) == 1 then 
			UseBayeriStahlHorn=0
	end
	if GetV(V_SKILLATTACKRANGE,myid,MH_HEILIGE_STANGE) == 1 then
			UseBayeriHailegeStar=0
	end
	if GetV(V_SKILLATTACKRANGE,myid,MH_NEEDLE_OF_PARALYZE) == 1 then
			UseSeraParalyze=0
	end
	if GetV(V_SKILLATTACKRANGE,myid,MH_POISON_MIST) == 1 then 
			UseSeraPoisonMist=0
	end
	if GetV(V_SKILLATTACKRANGE,myid,MH_LAVA_SLIDE) == 1 then
			UseDieterLavaSlide=0
	end
	if UseSmartBulwark==1 then
		SkillInfo[HAMI_DEFENCE][3]={140,145,150,155,160}
	end
	OnInit()
	DoneInit=1
end


--########################################
--### Friend the merc/homun - old one  ###
--### by Misch, new one by Dr. Azzy    ###
--########################################

if (AssumeHomun==1) then
	if (NewAutoFriend==0) then
		ff = {}
		Hactors = GetActors()
		Howner  = GetV(V_OWNER,Hactors[1])
		FX = 0
		FY = 0
		OX,OY = GetV(V_POSITION,Howner)
		for i,v in ipairs(Hactors) do
			if (v ~= Howner) then
				if (IsMonster(v)==0) then
					FX,FY = GetV(V_POSITION,v)
					if (FX==OX and FY==OY and v<100000) then --is not a player
						MyFriends[v]=2
					end
				end
			end
		end
	else
		NeedToDoAutoFriend=1
		TraceAI("Setting NeedToDoAutoFriend")
	end
end
--####################################
--######## Command Processing ########
--####################################

function	OnMOVE_CMD (x,y)
	
	TraceAI ("OnMOVE_CMD")
	
	ResetCounters()
	if ( x == MyDestX and y == MyDestY and MOTION_MOVE == GetV(V_MOTION,MyID)) then
		return
	end

	--local curX, curY = GetV (V_POSITION,MyID)
	--if (math.abs(x-curX)+math.abs(y-curY) > 15) then
	--	List.pushleft (ResCmdList,{MOVE_CMD,x,y})
	--	x = math.floor((x+curX)/2)  
	--	y = math.floor((y+curY)/2)
	--end
	MyMoveX,MyMoveY=x,y
	MyDestX,MyDestY=x,y
	Move (MyID,MyDestX,MyDestY)	
	MyState = MOVE_CMD_ST
	if (MirAIFriending==1) then --emulate MirAI's annoying friending process
		TraceAI("Starting Friend Routine")
		local actors = GetActors()
		for i,v in ipairs(actors) do
			if (IsMonster(v)~=1 and v~=GetV(V_OWNER,MyID) and v~=MyID) then
				xx,yy=GetV(V_POSITION,v)
				if (xx==x and (yy+1==y or yy-1==y)) then
					
					if (MyFriends[v]==nil) then
						MyFriends[v] = 1
						FriendsFile = io.open("AI/USER_AI/A_Friends.lua", "w")
						FriendsFile:write (STRING_A_FRIENDS_HEAD)
						for k,v in pairs(MyFriends) do
							if (v==1) then
								FriendsFile:write ("MyFriends["..k.."]="..v.." -- \n")
							end
						end
						FriendsFile:close()
						MyState=FRIEND_CIRCLE_ST
						TraceAI("Friend Addition")
						NewFriendX,NewFriendY=GetV(V_POSITION,v)
						return
					elseif (MyFriends[v]~=nil) then
						MyFriends[v] = nil
						FriendsFile = io.open("AI/USER_AI/A_Friends.lua", "w")
						FriendsFile:write (STRING_A_FRIENDS_HEAD)
						for k,v in pairs(MyFriends) do
							if (v==1) then
								FriendsFile:write ("MyFriends["..k.."]="..v.." -- \n")
							end
						end
						FriendsFile:close()
						MyState=FRIEND_CROSS_ST
						TraceAI("Friend Removal")
						NewFriendX,NewFriendY=GetV(V_POSITION,v)
						return
					end
				end
			end
		end
	end
end


function	OnSTOP_CMD ()

	TraceAI ("OnSTOP_CMD")
	logappend("AAI_ERROR","STOP_CMD sent! This should NEVER HAPPEN!")
	if (GetV(V_MOTION,MyID) ~= MOTION_STAND) then
		Move (MyID,GetV(V_POSITION,MyID))
	end
	MyState = IDLE_ST
	MyDestX = 0
	MyDestY = 0
	MyEnemy = 0
	EnemyPosX = {0,0,0,0,0,0,0,0,0,0}
	EnemyPosY = {0,0,0,0,0,0,0,0,0,0}
	MySkill = 0

end


function	OnATTACK_OBJECT_CMD (id)
	TraceAI ("OnATTACK_OBJECT_CMD")
	ResetCounters()
	MySkill = 0
	MyEnemy = id
	BypassKSProtect=1
	if (UseBerzerkAttack==1) then
		BerzerkMode=1
	end
	MyState = CHASE_ST
	OnCHASE_ST()
end


function	OnATTACK_AREA_CMD (x,y)

	TraceAI ("OnATTACK_AREA_CMD")
	logappend("AAI_ERROR","ATTACK_AREA_CMD sent! This should NEVER HAPPEN!")
	if (x ~= MyDestX or y ~= MyDestY or MOTION_MOVE ~= GetV(V_MOTION,MyID)) then
		Move (MyID,x,y)	
	end
	MyDestX = x
	MyDestY = y
	MyEnemy = 0
	EnemyPosX = {0,0,0,0,0,0,0,0,0,0}
	EnemyPosY = {0,0,0,0,0,0,0,0,0,0}
	MyState = ATTACK_AREA_CMD_ST
	
end

function	OnPATROL_CMD (x,y)

	TraceAI ("OnPATROL_CMD")
	logappend("AAI_ERROR","PATROL_CMD sent! This should NEVER HAPPEN!")
	MyPatrolX , MyPatrolY = GetV (V_POSITION,MyID)
	MyDestX = x
	MyDestY = y
	Move (MyID,x,y)
	MyState = PATROL_CMD_ST

end


function	OnHOLD_CMD ()

	TraceAI ("OnHOLD_CMD")
	logappend("AAI_ERROR","HOLD_CMD sent! This should NEVER HAPPEN!")
	MyDestX = 0
	MyDestY = 0
	MyEnemy = 0
	EnemyPosX = {0,0,0,0,0,0,0,0,0,0}
	EnemyPosY = {0,0,0,0,0,0,0,0,0,0}
	MyState = HOLD_CMD_ST

end


function	OnSKILL_OBJECT_CMD (level,skill,id)

	TraceAI ("OnSKILL_OBJECT_CMD"..skill.." "..id.." "..level)
	ResetCounters()
	MySkillLevel = level
	MySkill = skill
	MyEnemy = id
	if IsMonster(id)==1 then
		BypassKSProtect=1
		if (UseBerzerkSkill==1) then
			BerzerkMode=1
		end
		MyState = CHASE_ST
		OnCHASE_ST()
	else
		MyState = SKILL_OBJECT_CMD_ST
	end

end


function	OnSKILL_AREA_CMD (level,skill,x,y)
	ResetCounters()
	TraceAI ("OnSKILL_AREA_CMD")
	targetx,targety=Closest(MyID,x,y,AttackRange(MyID,skill,level))
	Move (MyID,targetx,targety)
	MyDestX = x
	MyDestY = y
	MySkillLevel = level
	MySkill = skill
	MyState = SKILL_AREA_CMD_ST
	
end

function	OnFOLLOW_CMD ()
	ReturnToMoveHold = 0 
	if (MyState ~= FOLLOW_CMD_ST) then
		if StickyStandby > 0 then
			ShouldStandby=1
		end
		BetterMoveToOwner (MyID,FollowStayBack)
		MyState = FOLLOW_CMD_ST
		MyEnemy = 0 
		EnemyPosX = {0,0,0,0,0,0,0,0,0,0}
		EnemyPosY = {0,0,0,0,0,0,0,0,0,0}
		MySkill = 0
		TraceAI ("OnFOLLOW_CMD")
	else
		if StickyStandby > 0 then
			ShouldStandby=0
		end
		MyState = IDLE_ST
		MyEnemy = 0 
		EnemyPosX = {0,0,0,0,0,0,0,0,0,0}
		EnemyPosY = {0,0,0,0,0,0,0,0,0,0}
		MySkill = 0
		TraceAI ("FOLLOW_CMD_ST --> IDLE_ST")
	end

end




function	ProcessCommand (msg)

	if	(msg[1] == MOVE_CMD) then
		TraceAI ("MOVE_CMD")
		OnMOVE_CMD (msg[2],msg[3])
	elseif	(msg[1] == STOP_CMD) then
		TraceAI ("STOP_CMD")
		OnSTOP_CMD ()
	elseif	(msg[1] == ATTACK_OBJECT_CMD) then
		TraceAI ("ATTACK_OBJECT_CMD")
		OnATTACK_OBJECT_CMD (msg[2])
	elseif	(msg[1] == ATTACK_AREA_CMD) then
		TraceAI ("ATTACK_AREA_CMD")
		OnATTACK_AREA_CMD (msg[2],msg[3])
	elseif	(msg[1] == PATROL_CMD) then
		TraceAI ("PATROL_CMD")
		OnPATROL_CMD (msg[2],msg[3])
	elseif	(msg[1] == HOLD_CMD) then
		TraceAI ("HOLD_CMD")
		OnHOLD_CMD ()
	elseif	(msg[1] == SKILL_OBJECT_CMD) then
		TraceAI ("SKILL_OBJECT_CMD")
		OnSKILL_OBJECT_CMD (msg[2],msg[3],msg[4],msg[5])
	elseif	(msg[1] == SKILL_AREA_CMD) then
		TraceAI ("SKILL_AREA_CMD")
		OnSKILL_AREA_CMD (msg[2],msg[3],msg[4],msg[5])
	elseif	(msg[1] == FOLLOW_CMD) then
		TraceAI ("FOLLOW_CMD")
		OnFOLLOW_CMD ()
	end
end

function ResetCounters()
	MySkillUsedCount		= 0
	ChaseGiveUpCount		= 0
	AttackGiveUpCount		= 0
	ChaseDebuffUsed			= 0
	AttackDebuffUsed		= 0
	BypassKSProtect			= 0
	BerzerkMode				= 0
	ReturnToState			= 0
	NewFriend				= 0
	FriendMotionTime		= 0
	FriendCircleIter		= 0
	FriendCircleTimeout		= 0
	AtkPosbugFixTimeout		= 0
	SkillObjectCMDTimeout	= 0
	FollowTryCount			= 0
	MyMoveX,MyMoveY			= 0,0
	return
end

--###############################
--######## State Process ########
--###############################


function	OnIDLE_ST ()
	if ReturnToMoveHold==1 then 
		MyState=MOVE_CMD_HOLD_ST
		OnMOVE_CMD_HOLD_ST()
		return
	end
	TraceAI ("OnIDLE_ST")
	ResetCounters()
	MySkill					= 0
	MyDestX					= 0
	MyDestY					= 0
	MyEnemy					= 0
	if (DoIdleTasks()==nil) then
		return
	end
	--StickyStandby handling
	if (ShouldStandby==1 and StickyStandby > 0) then
		MyState=FOLLOW_CMD_ST
		return
	end
	--Targeting
	if SuperPassive~=1 then
		local	object = SelectEnemy(GetFriendTargets())
		if (object ~= 0) then							-- MYOWNER_ATTACKED_IN
			MyState = CHASE_ST
			MyEnemy = object
			TraceAI ("IDLE_ST -> CHASE_ST : MYOWNER_ATTACKED_IN")
			if (FastChangeCount < FastChangeLimit and FastChange_I2C ==1) then
				OnCHASE_ST()
			end
			return 
		end
		if (HPPercent(MyID) > AggroHP and SPPercent(MyID) > AggroSP) then
			aggro=1
		else
			aggro=0
		end
		object=SelectEnemy(GetEnemyList(MyID,aggro))
		if object~=0 then
			MyState = CHASE_ST
			MyEnemy = object
			TraceAI ("IDLE_ST -> CHASE_ST : ATTACKED_IN")
			if (FastChangeCount < FastChangeLimit and FastChange_I2C ==1) then
				return OnCHASE_ST()
			end
			return	
		end
		if (aggro==1 and TankMonsterCount < TankMonsterLimit) then
			object = SelectEnemy(GetEnemyList(MyID,-1))
			if (object ~= 0) then
				MyState = TANKCHASE_ST
				MyEnemy = object
				TraceAI ("IDLE_ST -> TANKCHASE_ST")
				return
			end
		end
	end
	--Following
	local distance = GetDistanceFromOwner(MyID)
	if (UseRandWalk==1 or UseOrbitWalk==1 or UseRouteWalk == 1) then
		if ( distance > GetMoveBounds() or distance == -1) then		-- MYOWNER_OUTSIGNT_IN
			MyState = FOLLOW_ST
			TraceAI ("IDLE_ST -> FOLLOW_ST")
			return
		end
	elseif ( distance > DiagonalDist(FollowStayBack+1) or distance == -1) then		-- MYOWNER_OUTSIGNT_IN
		MyState = FOLLOW_ST
		TraceAI ("IDLE_ST -> FOLLOW_ST")
		return OnFOLLOW_ST()
	end
	local owner=GetV(V_OWNER,MyID)
	local ownermotion=GetV(V_MOTION,owner)
	if (distance < 2 and ownermotion == MOTION_STAND and (UseRandWalk==1 or UseRouteWalk==1) and HPPercent(MyID) > AggroHP) then
		DoRandomMove()
		return
	end
	if (ownermotion==0 and GetV(V_MOTION,MyID)==0 and UseOrbitWalk > 0) then
		MyState=ORBITWALK_ST
		OrbitWalkStep=0
		return
	end

end

function	OnFOLLOW_ST ()

	TraceAI ("OnFOLLOW_ST - follow try count: "..FollowTryCount)
	ReturnToMoveHold = 0
	if (GetDistanceFromOwner(MyID) <= DiagonalDist(FollowStayBack+1)) then		--  DESTINATION_ARRIVED_IN 
		FollowTryCount=0
		MyState = IDLE_ST
		TraceAI ("FOLLOW_ST -> IDLE_ST")
		if (FastChangeCount < FastChangeLimit and FastChange_F2I==1) then
			FastChangeCount = FastChangeCount+1
			return OnIDLE_ST()
		end
	else
		if (FollowTryCount > FollowTryPanic and GetV(V_MOTION,MyID)~=MOTION_MOVE) then
			if FollowTryCount > 2*FollowTryPanic then
				if FollowTryCount > 3*FollowTryPanic then 
					TraceAI("FOLLOW_ST -> IDLE_ST - Can't follow even using panic'ed methods - Giving up")
					MyState=IDLE_ST
					if (FastChangeCount < FastChangeLimit and FastChange_F2I==1) then
						FastChangeCount = FastChangeCount+1
						return OnIDLE_ST()
					end
				else
					MoveToOwner(MyID)
					FollowTryCount=FollowTryCount+1
					TraceAI("Emergency follow - MoveToOwner() called")
				end
			else
				FollowTryCount=FollowTryCount+1
				BetterMoveToOwner (MyID,1)
			end
		else
			BetterMoveToOwner (MyID,FollowStayBack)
			if (GetV(V_MOTION,MyID) ~= MOTION_MOVE) then
				FollowTryCount=FollowTryCount+1
			else
				FollowTryCount=0
			end
		end
		TraceAI ("FOLLOW_ST -> FOLLOW_ST")
		return
	end

end


function	OnCHASE_ST ()
	MyAttackStanceX,MyAttackStanceY = 0,0
	TraceAI ("OnCHASE_ST")
	if (UseSkillOnly==1 and MySkill ~= 0) then
		skill,level=GetAtkSkill(MyID)
	else
		skill=nil
		level=nil
	end
	if(IsNotKS(MyID,MyEnemy)==0) then
		MyState = IDLE_ST
		MyEnemy = 0
		EnemyPosX = {0,0,0,0,0,0,0,0,0,0}
		EnemyPosY = {0,0,0,0,0,0,0,0,0,0}
		MyDestX, MyDestY = 0,0
		ChaseGiveUpCount=0
		TraceAI ("CHASE_ST -> IDLE_ST : Enemy is taken")
		if (FastChangeCount < FastChangeLimit and FastChange_C2I == 1) then
			FastChangeCount = FastChangeCount+1
			return OnIDLE_ST()
		end
	end
	if (true == IsOutOfSight(MyID,MyEnemy)) then	-- ENEMY_OUTSIGHT_IN
	
		MyState = IDLE_ST
		MyEnemy = 0
		EnemyPosX = {0,0,0,0,0,0,0,0,0,0}
		EnemyPosY = {0,0,0,0,0,0,0,0,0,0}
		MyDestX, MyDestY = 0,0
		TraceAI ("CHASE_ST -> IDLE_ST : Enemy out of sight")
		ChaseGiveUpCount=0
		
		if (FastChangeCount < FastChangeLimit and FastChange_C2I == 1) then
			FastChangeCount = FastChangeCount+1
			return OnIDLE_ST()
		else
			return
		end
	end
	if GetV(V_MOTION,MyID)~=MOTION_MOVE then
		if ChaseGiveUpCount > ChaseGiveUp then
			Unreachable[MyEnemy]=1
			if SelectEnemy(GetEnemyList(MyID,-2)) == MyEnemy then --Oh crap, 
				TraceAI("CHASE_ST -> FOLLOW_ST : Target "..MyEnemy.." marked unreachable but is also rescue target! Trying follow state in hopes of a clean line of attack from owner")
				MyState = FOLLOW_ST
				MyEnemy = 0
				EnemyPosX = {0,0,0,0,0,0,0,0,0,0}
				EnemyPosY = {0,0,0,0,0,0,0,0,0,0}
				MyDestX,MyDestY=0,0
		        ChaseGiveUpCount=0
				return OnFOLLOW_ST()
			else
				MyState = IDLE_ST
				MyDestX, MyDestY = 0,0
				TraceAI ("CHASE_ST -> IDLE_ST : Marking target "..MyEnemy.." unreachable")
				ChaseGiveUpCount=0
				MyEnemy = 0
				EnemyPosX = {0,0,0,0,0,0,0,0,0,0}
				EnemyPosY = {0,0,0,0,0,0,0,0,0,0}
				if (FastChangeCount < FastChangeLimit and FastChange_C2I == 1) then
					FastChangeCount = FastChangeCount+1
					return OnIDLE_ST()
				else
					return
				end
			end
		end
		ChaseGiveUpCount=ChaseGiveUpCount+1
	end
	if (true == IsInAttackSight(MyID,MyEnemy,skill,level)) then  -- ENEMY_INATTACKSIGHT_IN
		MyState = ATTACK_ST
		ChaseGiveUpCount=0
		MySkillUsedCount=0
		TraceAI ("CHASE_ST -> ATTACK_ST : ENEMY_INATTACKSIGHT_IN")
		if (FastChangeCount < FastChangeLimit and FastChange_C2A == 1) then
			FastChangeCount = FastChangeCount+1
			return OnATTACK_ST()
		else
			return
		end
	elseif UseSkillOnly == -1 and (GetTick() >= AutoSkillTimeout) then
		dist=GetDistance2(MyID,MyEnemy)
		tact_debuff,tact_skill,tact_skillclass=GetTact(TACT_DEBUFF,MyEnemy),GetTact(TACT_SKILL,MyEnemy),GetTact(TACT_SKILLCLASS,MyEnemy)
		skilltouse={-1,0,0}
		local SkillList=GetTargetedSkills(MyID)
		TraceAI("Begin autoskill while chasing routine")
		if (tact_skill < 0) then		-- Negative value of TACT_SKILL -> 1 cast of skill
			skill_level=tact_skill*-1	-- with level = to the absolute value of the
			tact_skill=1			-- value of TACT_SKILL.
		else
			skill_level=11
		end
		local availsp = GetV(V_SP,MyID)
		if BerserkMode~=1 or Berzerk_IgnoreMinSP ~=1 then
			availsp = availsp - UseAutoSkill_MinSP
		end
		for i,v in SkillList do

			skilltype=v[1]
			if v[2]~=0 then
				if (availsp >= SkillInfo[v[2]][3][math.min(v[3],skill_level)] and SkillInfo[v[2]][2][math.min(v[3],skill_level)] >= dist) then 
					if (skilltype == MOB_ATK and (MySkillUsedCount < tact_skill or tact_skill==SKILL_ALWAYS or (BerzerkMode==1 and Berzerk_SkillAlways==1))) then
						if (tact_skillclass == CLASS_MOB) then
							if (skilltouse[1] < 2) then
								skilltouse=v
							end
						end
					elseif (skilltype ==DEBUFF_ATK and ChaseDebuffUsed==0) then
						if (tact_debuff*-1 == v[2] or (tact_debuff==1 and BasicDebuffs[v[2]]~=nil)) then
							skilltouse=v
						end
					elseif (skilltype==MAIN_ATK and (MySkillUsedCount < tact_skill or tact_skill==SKILL_ALWAYS or (BerzerkMode==1 and Berzerk_SkillAlways==1)) and tact_skillclass~=CLASS_S) then
						skilltouse=v
					elseif (skilltype==S_ATK and UseHomunSSkillChase==1 and (MySkillUsedCount < tact_skill or tact_skill==SKILL_ALWAYS or (BerzerkMode==1 and Berzerk_SkillAlways==1)) and tact_skillclass~=CLASS_OLD) then
						skilltouse=v
					end
				end
			end
		end
		if skilltouse[2]~=0 then
			TraceAI("Using skill while chasing:"..skilltouse[2])
			local slvl=skilltouse[3]
			if skill_level~=11 then
				slvl=skill_level
			end
			DoSkill(skilltouse[2],slvl,MyEnemy)
			if skilltouse[1] == DEBUFF_ATK then
				ChaseDebuffUsed=1
			end
			MySkillUsedCount=1
		end
	else
		TraceAI("Not in range, and can't use chase skill")
	end
	if (DoNotChase~=1) then
		local alt = 0
		if (ChaseGiveUpCount >= 4 and MyPosX[1] == MyPosX[3]  and MyPosY[1]==MyPosY[3]) then
			alt=math.random(2)
			TraceAI("Using alt movement"..alt)
		end
		ex,ey=GetV(V_POSITION,MyEnemy)
		if ChaseGiveUpCount > 7 and IsMonster(MyEnemy)==1 then
			x,y=ex,ey
		elseif EnemyPosX[3]~=0 and (ex~=EnemyPosX[3] or ey~=EnemyPosY[3]) then
			dx,dy = ex-EnemyPosX[3],ey-EnemyPosY[3]
			x,y = Closest(MyID,ex+dx,ey+dy,AttackRange(MyID,MySkill,MySkillLevel),alt)
		else
			x,y = ClosestR(MyID,MyEnemy,AttackRange(MyID,MySkill,MySkillLevel),alt)
		end
		ox,oy=GetV(V_POSITION,GetV(V_OWNER,MyID))
		if GetDistanceAPR(GetV(V_OWNER,MyID),x,y) < GetMoveBounds() then
			if ((x~=MyDestX or y~=MyDestY) or GetV(V_MOTION,MyID)~=MOTION_MOVE)  then
				MyDestX, MyDestY=x,y
				Move (MyID,MyDestX,MyDestY)
				TraceAI ("CHASE_ST -> CHASE_ST : DESTCHANGED_IN "..MyDestX..","..MyDestY.."mypos "..MyPosX[1]..","..MyPosY[1].."owner pos"..ox..","..oy.." enemypos "..ex..","..ey.." GetDistanceAPR="..GetDistanceAPR(GetV(V_OWNER,MyID),x,y))
			else
				TraceAI("CHASE_ST -> CHASE_ST : Destination not changed "..MyDestX..","..MyDestY.."mypos "..MyPosX[1]..","..MyPosY[1].."owner pos"..ox..","..oy.." enemypos "..ex..","..ey.." GetDistanceAPR="..GetDistanceAPR(GetV(V_OWNER,MyID),x,y))
			end
		else --if ChaseGiveUpCount > 4 then
			MyState = IDLE_ST
			Unreachable[MyEnemy]=1
			MyEnemy = 0
			EnemyPosX = {0,0,0,0,0,0,0,0,0,0}
			EnemyPosY = {0,0,0,0,0,0,0,0,0,0}
			MyDestX, MyDestY = 0,0
			TraceAI ("CHASE_ST -> IDLE_ST : Following enemy would exceed move bounds."..x..","..y.."mypos "..MyPosX[1]..","..MyPosY[1].."owner pos"..ox..","..oy.." enemypos "..ex..","..ey.." GetDistanceAPR="..GetDistanceAPR(GetV(V_OWNER,MyID),x,y))
			ChaseGiveUpCount=0
			if (FastChangeCount < FastChangeLimit and FastChange_C2I == 1) then
				FastChangeCount = FastChangeCount+1
				return OnIDLE_ST()
			end
		--else
		--	ChaseGiveUpCount=5
		--	TraceAI ("CHASE_ST -> CHASE_ST : Following enemy would exceed move bounds, setting ChaseGiveUpCount to 5 in the hopes that the alt destination next round is better "..x..","..y.."mypos "..MyPosX[1]..","..MyPosY[1].."owner pos"..ox..","..oy.." enemypos "..ex..","..ey.." GetDistanceAPR="..GetDistanceAPR(GetV(V_OWNER,MyID),x,y))
		end
	end
	return
end




function	OnATTACK_ST ()
	TraceAI ("OnATTACK_ST")	
	if (true == IsOutOfSight(MyID,MyEnemy)) then -- first thing's first, if enemy is gone drop it. 
		MyState = IDLE_ST
		MyEnemy = 0
		EnemyPosX = {0,0,0,0,0,0,0,0,0,0}
		EnemyPosY = {0,0,0,0,0,0,0,0,0,0}
		MySkillUseCount= 0
		TraceAI ("ATTACK_ST -> IDLE_ST -- target gone")
		return OnIDLE_ST()
	end
	if (MOTION_DEAD == GetV(V_MOTION,MyEnemy)) then   -- Enemy dead? Okay we're done here - drop it. 
		MyState = IDLE_ST
		MyEnemy = 0
		EnemyPosX = {0,0,0,0,0,0,0,0,0,0}
		EnemyPosY = {0,0,0,0,0,0,0,0,0,0}
		MySkillUseCount= 0
		TraceAI ("ATTACK_ST -> IDLE_ST  Enemy dead")
		return OnIDLE_ST()
	end
	
	local skill,level
	mob,aggro = GetMobCount(MyID,100,GetV(V_OWNER,MyID))
	if(aggro > UseBerzerkMobbed and UseBerzerkMobbed > 0)then
		BerzerkMode=1
	end	
	if UseSkillOnly==1 then
		skill,level=GetAtkSkill(MyID)
	elseif MySkill~=0 then
		skill,level=MySkill,MySkillLevel
	else 
		skill,level=nil,nil
	end
	
	if (false == IsInAttackSight(MyID,MyEnemy,skill,level)) then  -- Check if we can attack enemy, if not back to chase 
		ResetCounters()
		MyState=CHASE_ST
		TraceAI ("ATTACK_ST -> CHASE_ST  : ENEMY_OUTATTACKSIGHT_IN MyEnemy: "..MyEnemy.." distance to "..GetDistance2(MyID,MyEnemy))
		if (FastChangeCount < FastChangeLimit and FastChange_A2C == 1) then
			FastChangeCount = FastChangeCount+1
			return OnCHASE_ST()
		end
	end
	--### START SECTION TO DETECT OBSTACLES AND POSBUG ###---
	if (GetV(V_TARGET,MyID)~=MyEnemy and MyStates[1]~=ATTACK_ST) then--and GetV(V_TARGET,MyID)~=0) then  -- troubles getting to target for first attack, assume obstacles. 
		AttackGiveUpCount=AttackGiveUpCount+1
		if (AttackGiveUpCount >= 3 and AttackGiveUpCount <= AttackGiveUp) then
			MyDestX, MyDestY = ClosestR (MyID,MyEnemy,math.max(AttackRange(MyID,MySkill,MySkillLevel)-1,1),math.floor((AttackGiveUpCount-1)/2))
			Move (MyID,MyDestX,MyDestY)
		elseif (AttackGiveUpCount > AttackGiveUp) then
			Unreachable[MyEnemy]=1
			MyState = IDLE_ST
			MyEnemy = 0
			EnemyPosX = {0,0,0,0,0,0,0,0,0,0}
			EnemyPosY = {0,0,0,0,0,0,0,0,0,0}
			MySkillUseCount= 0
			TraceAI ("ATTACK_ST -> IDLE_ST - Can't target enemy, marked as unreachable")
			return OnIDLE_ST()
		end
	else
		AttackGiveUpCount=0
		attackok=1
	end
    --### END SECTION TO DETECT OBSTACLES AND POSBUG ###---
	if (MyAttackStanceX==0) then
		x,y=GetV(V_POSITION,MyID)
		MyAttackStanceX,MyAttackStanceY=x,y
		--logappend("AAI_Dance","Attack Stance set to "..MyDestX..","..MyDestY.." current pos: "..x..","..y)
	end
	if (UseAutoPushback > 0) then
		if DoAutoPushback(MyID)  == nil then
			return
		end
	end

	local tact_skill,tact_debuff,tact_skillclass=GetTact(TACT_SKILL,MyEnemy),GetTact(TACT_DEBUFF,MyEnemy),GetTact(TACT_SKILLCLASS,MyEnemy)
	local skill_level
	local mobcount,aggrocount=GetMobCount(MyID,2,GetV(V_OWNER,MyID))
	
	--Sniping routine
	if (IsHomun(MyID)==1 and BerzerkMode==0 and (GetTick() >= AutoSkillTimeout)) then
		target=SelectEnemy(GetEnemyList(MyID,2)) -- This actually checks range - I know it's ugly to do it there, skill range checks need to be done at that point :-(
		if target ~=0 then
			snipeskill=0
			snipe_tact_skillclass=GetTact(TACT_SKILLCLASS,target)
			if snipe_tact_skillclass ~= CLASS_OLD then
				snipeskill,snipelevel=GetSAtkSkill(MyID)
			end
			if snipeskill==0 and snipe_tact_skillclass ~= CLASS_S then
				snipeskill,snipelevel=GetAtkSkill(MyID)
			end
			--TraceAI("snipe "..skill.." level"..level)
			if snipeskill ~=0 then
				slevel = GetTact(TACT_SKILL,target)
				if slevel < 0 then
					slevel=-1*slevel
					if slevel > snipelevel then
						slevel = snipelevel
					end
					if ((GetV(V_SP,MyID) >= UseAutoSkill_MinSP+SkillInfo[snipeskill][3][slevel])) and IsInAttackSight(MyID,target,snipeskill,slevel) then
						TraceAI("Snipe attack on "..target.." "..snipeskill.." "..slevel)
						DoSkill(snipeskill,slevel,target)
					end
				end
			end
		end
	end
	
	
	-- Begin skill selection routine
	skilltouse = {-1,0,0}
	-- First digit (1): -1 = no skill, 0 single target, 1 debuff, 2 mob
	-- Second digit (2): skill id
	-- Third digit (3): skill level
	if (1==1) then --non paniced attack
		if (MySkill==0 and UseAutoSkill == 1 and GetTick() >= AutoSkillTimeout) then	
			if (tact_skill < 0) then		-- Negative value of TACT_SKILL -> 1 cast of skill
				skill_level=tact_skill*-1	-- with level = to the absolute value of the
				tact_skill=1			-- value of TACT_SKILL.
			else
				skill_level=11
			end
			local SkillList=GetTargetedSkills(MyID)
			TraceAI("Begin autoskill routine")
			local availsp = GetV(V_SP,MyID)
			if BerserkMode~=1 or Berzerk_IgnoreMinSP ~=1 then
				availsp = availsp - UseAutoSkill_MinSP
			end
			for i,v in SkillList do
				skilltype=v[1]
				TraceAI("skilltype ".. skilltype.." MySkillUsedCount "..MySkillUsedCount.." tact_skill ".. tact_skill.." tact_skillclass"..tact_skillclass.."v"..v[1].." "..v[2].." "..v[3])
						
				if v[2]~=0 then
					if IsInAttackSight(MyID,MyEnemy,v[2],v[3])==true then
						if (skilltype == MOB_ATK and (MySkillUsedCount < tact_skill or tact_skill==SKILL_ALWAYS or (BerzerkMode==1 and Berzerk_SkillAlways==1))) then
						local mobskill_level=skill_level
						if MobSkillFixedLevel == 1 then
							mobskill_level=v[3]
						end
						mobskillcount=GetAOECount(MyID,MyEnemy,v[2],math.min(v[3],mobskill_level))
							--logappend("AAI_mobcount","mobskillcount="..mobskillcount.."tact_skillclass="..tact_skillclass.."class_mob="..CLASS_MOB.."AutoMobCount="..AutoMobCount)
							if (mobskillcount >= AutoMobCount or tact_skillclass == CLASS_MOB) then
								if (availsp >= SkillInfo[v[2]][3][math.min(v[3],mobskill_level)])then
									if (skilltouse[1] < 2) then
										skilltouse=v
									end
								end
							end
						elseif (skilltype ==DEBUFF_ATK and AttackDebuffUsed < AttackDebuffLimit) then
							if (tact_debuff*-1 == v[2] or (tact_debuff==1 and BasicDebuffs[v[2]]~=nil)) then
								if (availsp >= SkillInfo[v[2]][3][math.min(v[3],skill_level)]) then
									skilltouse=v
								end
							end
						elseif (skilltype==MAIN_ATK and (MySkillUsedCount < tact_skill or tact_skill==SKILL_ALWAYS or (BerzerkMode==1 and Berzerk_SkillAlways==1)) and tact_skillclass~=CLASS_S) then
							if (availsp >= SkillInfo[v[2]][3][math.min(v[3],skill_level)]) then
								skilltouse=v
							end
						elseif (skilltype==S_ATK and UseHomunSSkillAttack==1 and (MySkillUsedCount < tact_skill or tact_skill==SKILL_ALWAYS or (BerzerkMode==1 and Berzerk_SkillAlways==1)) and tact_skillclass~=CLASS_OLD) then
							if (availsp >= SkillInfo[v[2]][3][math.min(v[3],skill_level)]) then
								skilltouse=v
							end
						end
					end
				end
				TraceAI("skill selected "..skilltouse[2])
			end
		end
		-- Now we finalize the selection
		if skilltouse[1]~= -1 then
			MySkill=skilltouse[2]
			if (IsHomun(MyID)==1 and skill_level~=11 and (skilltouse[1]~=MOB_ATK or MobSkillFixedLevel ~= 1)) then  	--no need to check what skill
				MySkillLevel=skill_level			--Only homuns can use non-max level
			else							--and they dont have any mob/debuffs
				MySkillLevel=skilltouse[3]
			end
			if (skilltouse[1] == DEBUFF_ATK) then
				AttackDebuffUsed=AttackDebuffUsed+1
			else
				MySkillUsedCount=MySkillUsedCount+1
			end
		end	
	end
	
	-- Now we resolve it
	
	--if (MySkill == 0) then
	if (UseSkillOnly ~= 1) then
		Attack (MyID,MyEnemy)
		TraceAI("Normal attack vs: "..MyEnemy)
	end
	-- else
	if (MySkill ~=0) then
		TraceAI("Skill Attack: "..MySkill.." target: "..MyEnemy)
		SkillTarget=MyEnemy
		if (MySkill==MA_SHARPSHOOTING and UseSmartFAS==1) then
			target,hitcount=GetBestFASTarget(MyID)
			TraceAI(target.." - "..hitcount)
			if hitcount > 0 and target~=-1 then
				SkillTarget=target
			elseif hitcount== 0 then
				MySkill=0
			end
			TraceAI("Skill Attack: "..MySkill.." (FAS) target: "..SkillTarget.." enemy: "..MyEnemy)			
		elseif (MySkill==ML_BRANDISH and UseSmartBrandish==1) then
			target=GetBestBrandishTarget(MyID)
			if target~=-1 then
				SkillTarget=target
			end
			TraceAI("Skill Attack: "..MySkill.." (brandish) target: "..SkillTarget.." enemy: "..MyEnemy)
		else
			TraceAI("Skill Attack: "..MySkill.." target: "..MyEnemy)
		end
		--if MySkill ~=0 then
		TraceAI("Attack Calling DoSkill"..MySkill.."lvl"..MySkillLevel.."target"..SkillTarget)
		DoSkill(MySkill,MySkillLevel,SkillTarget)
		--end
	end
	if (UseDanceAttack==1 or (BerzerkMode==1 and Berzerk_Dance==1) or (panicmode==1 and Panic_UseDanceAttack==1 and HPPercent(MyID) > FleeHP)) and (IsHomun(MyID)==1 and MySkill==0) and GetDistanceRect(MyEnemy,GetV(V_OWNER,MyID)) < 13 then
		nx,ny=GetDanceCell(MyAttackStanceX,MyAttackStanceY,MyEnemy)
		if GetDistanceAPR(GetV(V_OWNER,MyID),nx,ny) >= GetMoveBounds() then
			--TraceAI("Dance attack canceled, too close to move bounds "..GetDistanceAPR(GetV(V_OWNER,MyID),nx,ny).." "..GetMoveBounds())
		else 
			--TraceAI("Danceing between "..MyAttackStanceX..","..MyAttackStanceY.." and "..nx..","..ny)
			Move(MyID,nx,ny)
			Attack(MyID,MyEnemy)
			Move(MyID,MyAttackStanceX,MyAttackStanceY)
		end
		--x,y=GetV(V_POSITION,MyID)
		--if x~=MyAttackStanceX or y~=MyAttackStanceY or ((MyMotions[1]==MOTION_STAND or MyMotions[1]==MOTION_DAMAGE) and (MyMotions[2]==MOTION_STAND or MyMotions[2]==MOTION_DAMAGE) and (MyMotions[3]==MOTION_STAND or MyMotions[3]==MOTION_DAMAGE) and MyPosX[1]==MyPosX[2]==MyPosX[3] and MyPosY[1]==MyPosY[2]==MyPosY[3] ) then
		--	Move(MyID,MyAttackStanceX,MyAttackStanceY)
		--	logappend("AAI_Dance","DanceAttack move to attackstance "..x..","..y.." stance "..MyAttackStanceX..","..MyAttackStanceY)
		--else
		--	Move(MyID,nx,ny)
		--	logappend("AAI_Dance","DanceAttack move to dancecell "..x..","..y.." stance "..MyAttackStanceX..","..MyAttackStanceY.." dest "..nx..","..ny)
		--end
	else 
		TraceAI("dance attack not enabled "..UseDanceAttack.." "..IsHomun(MyID).." "..MySkill)
	end
	MySkill = 0
	MySkillLevel=0
end


-------------------
-- TANK ROUTINES --
-------------------

function	OnTANKCHASE_ST ()
	--if (UseSkillOnly==1) then
	--	skill,level=GetAtkSkill(MyID)
	--elseif (UseSkillOnly==-1) then
	--	skill,level=GetAtkSkill(MyID)
	--	if (GetV(V_SP,MyID)-UseAutoSkill_MinSP < SkillInfo[skill][3][level]) then
	--		skill,level,sp=nil,nil,nil
	--	end
	--else
	--	skill,level,sp=nil,nil,nil
	--end
	TraceAI ("OnTANKCHASE_ST")
	if (true == IsOutOfSight(MyID,MyEnemy) or (ChaseGiveUpCount > ChaseGiveUp and GetV(V_MOTION,MyID)~=MOTION_MOVE)) then	-- ENEMY_OUTSIGHT_IN
		if (ChaseGiveUpCount>ChaseGiveUp) then
			Unreachable[MyEnemy]=1
		end
		
		MyState = IDLE_ST
		MyEnemy = 0
		EnemyPosX = {0,0,0,0,0,0,0,0,0,0}
		EnemyPosY = {0,0,0,0,0,0,0,0,0,0}
		MyDestX, MyDestY = 0,0
		TraceAI ("TANKCHASE_ST -> IDLE_ST : ENEMY_OUTSIGHT_IN")
		ChaseGiveUpCount=0
		
		return
	end
	if (true == IsInAttackSight(MyID,MyEnemy)) then  -- ENEMY_INATTACKSIGHT_IN
		ChaseGiveUpCount=0
		if(IsNotKS(MyID,MyEnemy)==1) then
			MyState = TANK_ST
			MySkillUsedCount=0
			TraceAI ("TANKCHASE_ST -> TANK_ST : ENEMY_INATTACKSIGHT_IN")
			return OnTANK_ST()
		else
			MyState = IDLE_ST
			MyEnemy = 0
			EnemyPosX = {0,0,0,0,0,0,0,0,0,0}
			EnemyPosY = {0,0,0,0,0,0,0,0,0,0}
			MyDestX, MyDestY = 0,0
			TraceAI ("TANKCHASE_ST -> IDLE_ST : Enemy is taken")
		end
		
		return
	end
	TraceAI("Tank chase: Can we skill while chasing?")
	if UseSkillOnly == -1 and (GetTick() >= AutoSkillTimeout) then
		dist=GetDistance2(MyID,MyEnemy)
		tact_debuff,tact_skill,tact_skillclass=GetTact(TACT_DEBUFF,MyEnemy),GetTact(TACT_SKILL,MyEnemy),GetTact(TACT_SKILLCLASS,MyEnemy)
		skilltouse={-1,0,0}
		local SkillList=GetTargetedSkills(MyID)
		TraceAI("Begin autoskill while tank chasing routine")
		if (tact_skill < 0) then		-- Negative value of TACT_SKILL -> 1 cast of skill
			skill_level=tact_skill*-1	-- with level = to the absolute value of the
			tact_skill=1			-- value of TACT_SKILL.
		else
			skill_level=11
		end
		for i,v in SkillList do

			skilltype=v[1]
			if v[2]~=0 then
				--logappend("AAI_Chase","skilltype ".. skilltype.." MySkillUsedCount "..MySkillUsedCount.." tact_skill ".. tact_skill.." tact_skillclass ".. tact_skillclass.."v"..v[1].." "..v[2].." "..v[3])
				if (GetV(V_SP,MyID) >= UseAutoSkill_MinSP+SkillInfo[v[2]][3][math.min(v[3],skill_level)] and SkillInfo[v[2]][2][math.min(v[3],skill_level)] >= dist) then 
				--TraceAI("skilltype ".. skilltype.." MySkillUsedCount "..MySkillUsedCount.." tact_skill ".. tact_skill.."v"..v[1].." "..v[2].." "..v[3])
					if (skilltype == MOB_ATK and (MySkillUsedCount < tact_skill or tact_skill==SKILL_ALWAYS or (BerzerkMode==1 and Berzerk_SkillAlways==1))) then
						if (tact_skillclass == CLASS_MOB) then
							if (skilltouse[1] < 2) then
								skilltouse=v
							end
						end
					elseif (skilltype ==DEBUFF_ATK and ChaseDebuffUsed==0) then
						if (tact_debuff*-1 == v[2] or (tact_debuff==1 and BasicDebuffs[v[2]]~=nil)) then
							skilltouse=v
						end
					elseif (skilltype==MAIN_ATK and (MySkillUsedCount < tact_skill or tact_skill==SKILL_ALWAYS or (BerzerkMode==1 and Berzerk_SkillAlways==1)) and tact_skillclass~=CLASS_S) then
						skilltouse=v
					elseif (skilltype==S_ATK and UseHomunSSkillChase==1 and (MySkillUsedCount < tact_skill or tact_skill==SKILL_ALWAYS or (BerzerkMode==1 and Berzerk_SkillAlways==1)) and tact_skillclass~=CLASS_OLD) then
						skilltouse=v
					end
				end
			end
		end
		if skilltouse[2]~=0 then
			TraceAI("Using skill while tank chasing:"..skilltouse[2])
			local slvl=skilltouse[3]
			if skill_level~=11 then
				slvl=skill_level
			end
			DoSkill(skilltouse[2],slvl,MyEnemy)
			if skilltouse[1] == DEBUFF_ATK then
				ChaseDebuffUsed=1
			end
			MySkillUsedCount=1
		end
	else
		TraceAI("Not in range, and can't use chase skill")
	end
	ChaseGiveUpCount=ChaseGiveUpCount+1
	MyDestX, MyDestY = ClosestR (MyID,MyEnemy,AttackRange(MyID,MySkill,MySkillLevel))
	if (DoNotChase~=1) then
		Move (MyID,MyDestX,MyDestY)
		TraceAI ("TANKCHASE_ST -> TANKCHASE_ST : DESTCHANGED_IN"..MyDestX.." "..MyDestY)
	end
	return
end 

function OnTANK_ST()
	if (GetV(V_MOTION,MyEnemy)==MOTIONDEAD or IsOutOfSight(MyID,MyEnemy)) then
		MyState=IDLE_ST
		TraceAI("TANK_ST->IDLE_ST - Target dead or out of sight")
		return
	end
	if (GetV(V_TARGET,MyEnemy)~=MyID and (TankHitTimeout + 1500) < GetTick()) then
		TankHitTimeout = GetTick()
		if (IsInAttackSight(MyID,MyEnemy)==true) then
			Attack(MyID,MyEnemy)
		else
			MyState=TANKCHASE_ST
			TraceAI("TANK_ST->TANKCHASE_ST - Target out of range")
		end
		return
	end
	if GetV(V_TARGET,MyEnemy)==MyID then
		TraceAI("TANK_ST->IDLE_ST - Target is tanked successfully")
		MyState=IDLE_ST
	end
end

--------------------
--- REST ROUTINE ---
--------------------
function	OnREST_ST ()
	TraceAI("OnREST_ST")
	if (DoIdleTasks()==nil) then
		return
	end
	local	object = SelectEnemy(GetFriendTargets())
	if (object ~= 0) then		--Check for monsters attacking owner
		MyState = CHASE_ST
		MyEnemy = object
		TraceAI ("REST_ST -> CHASE_ST : MYOWNER_ATTACKED_IN")
		return 
	end
	object = SelectEnemy(GetEnemyList(MyID,0))	
	if (object ~= 0) then
		MyState = CHASE_ST
		MyEnemy = object
		TraceAI ("REST_ST -> CHASE_ST : ATTACKED_IN")
		return
	end
	
	--If theres nothing else to do, return to the "rest station"
	
	x,y=GetV(V_POSITION,MyID)
	ox,oy=GetV(V_POSITION,GetV(V_OWNER,MyID))
	xoff=x-ox
	yoff=y-oy
	TraceAI(xoff.." "..ox.." "..x)
	if (GetV(V_MOTION,GetV(V_OWNER,MyID))~=MOTION_SIT) then
		MyState=IDLE_ST
		TraceAI("REST_ST -> IDLE_ST: Owner stood up")
	elseif (xoff~=RestXOff or yoff~=RestYOff) then
		MyDestX=ox+RestXOff
		MyDestY=oy+RestYOff
		Move(MyID,MyDestX,MyDestY)
	end
end

-----------------------------
---Friend motion routines ---
-----------------------------
function	OnFRIEND_CIRCLE_ST()
	x,y = GetV(V_POSITION,MyID)
	dist = GetDistance(x,y,NewFriendX,NewFriendY)
	TraceAI("OnFRIEND_CIRCLE_ST"..x..","..y.." "..dist) 
	if FriendCircleIter == 0 then
		if dist > 2 then
			Move(MyID,NewFriendX,NewFriendY)
			FriendCircleTimeout=FriendCircleTimeout+1
			if FriendCircleTimeout > 16 then
				MyState=IDLE_ST
				TraceAI("Dropping circle attempt, timeout exceeded")
			end
			return
		else
			FriendCircleIter=1
		end
	end
	if FriendCircleIter ==1 then
		if x==NewFriendX and y==NewFriendY-2 then
			FriendCircleIter=2
			FriendCircleTimeout=0
		else 
		 	Move(MyID,NewFriendX,NewFriendY-2)
		 	FriendCircleTimeout=FriendCircleTimeout+1
		 	if FriendCircleTimeout>4 then
		 		FriendCircleIter=2
				FriendCircleTimeout=0
		 		TraceAI("giving up on circle step 1")	
		 	end
		 	return
		end
	end
	if FriendCircleIter ==2 then
		if x==NewFriendX-2 and y==NewFriendY then
			FriendCircleIter=3
			FriendCircleTimeout=0
		else 
		 	Move(MyID,NewFriendX-2,NewFriendY)
		 	FriendCircleTimeout=FriendCircleTimeout+1
		 	if FriendCircleTimeout>4 then
		 		FriendCircleIter=3
				FriendCircleTimeout=0
		 		TraceAI("giving up on circle step 2")	
		 	end
		 	return
		end
	end
	if FriendCircleIter ==3 then
		if x==NewFriendX and y==NewFriendY+2 then
			FriendCircleIter=4
			FriendCircleTimeout=0
		else 
			Move(MyID,NewFriendX,NewFriendY+2)
			FriendCircleTimeout=FriendCircleTimeout+1
			if FriendCircleTimeout>4 then
				FriendCircleIter=4
				FriendCircleTimeout=0
				TraceAI("giving up on circle step 3")	
			end
			return
		end
	end
	if FriendCircleIter ==4 then
		if x==NewFriendX+2 and y==NewFriendY then
			FriendCircleIter=5
			FriendCircleTimeout=0
		else 
			Move(MyID,NewFriendX+2,NewFriendY)
			FriendCircleTimeout=FriendCircleTimeout+1
			if FriendCircleTimeout>4 then
				FriendCircleIter=5
				FriendCircleTimeout=0
				TraceAI("giving up on circle step 4")	
			end
			return
		end
	end
	if FriendCircleIter == 5 then
		if x==NewFriendX and y==NewFriendY-2 then
			FriendCircleIter=0
			FriendCircleTimeout=0
			MyState=IDLE_ST
			TraceAI("Circle completed")
			return
		else 
			Move(MyID,NewFriendX,NewFriendY-2)
			FriendCircleTimeout=FriendCircleTimeout+1
			if FriendCircleTimeout>4 then
				FriendCircleIter=0
				FriendCircleTimeout=0
				MyState=IDLE_ST
				TraceAI("giving up on circle step 5")	
			end
			return
		end
	end
end

function	OnFRIEND_CROSS_ST()
	x,y = GetV(V_POSITION,MyID)
	dist = GetDistance(x,y,NewFriendX,NewFriendY)
	TraceAI("OnFRIEND_CROSS_ST"..x..","..y.." "..dist) 
	if FriendCircleIter == 0 then
		if dist > 2 then
			Move(MyID,NewFriendX,NewFriendY)
			FriendCircleTimeout=FriendCircleTimeout+1
			if FriendCircleTimeout > 16 then
				MyState=IDLE_ST
				TraceAI("Dropping cross attempt, timeout exceeded")
			end
			return
		else
			FriendCircleIter=1
		end
	end
	if FriendCircleIter ==1 then
		if x==NewFriendX-2 and y==NewFriendY then
			FriendCircleIter=2
			FriendCircleTimeout=0
		else 
		 	Move(MyID,NewFriendX-2,NewFriendY)
		 	FriendCircleTimeout=FriendCircleTimeout+1
		 	if FriendCircleTimeout>4 then
		 		FriendCircleIter=2
				FriendCircleTimeout=0
		 		TraceAI("giving up on cross step 1")	
		 	end
		 	return
		end
	end
	if FriendCircleIter ==2 then
		if x==NewFriendX+2 and y==NewFriendY then
			FriendCircleIter=3
			FriendCircleTimeout=0
		else 
		 	Move(MyID,NewFriendX+2,NewFriendY)
		 	FriendCircleTimeout=FriendCircleTimeout+1
		 	if FriendCircleTimeout>4 then
		 		FriendCircleIter=3
				FriendCircleTimeout=0
		 		TraceAI("giving up on cross step 2")	
		 	end
		 	return
		end
	end
	if FriendCircleIter ==3 then
		if x==NewFriendX-2 and y==NewFriendY then
			FriendCircleIter=4
			FriendCircleTimeout=0
		else 
			Move(MyID,NewFriendX-2,NewFriendY)
			FriendCircleTimeout=FriendCircleTimeout+1
			if FriendCircleTimeout>4 then
				FriendCircleIter=4
				FriendCircleTimeout=0
				TraceAI("giving up on cross step 3")	
			end
			return
		end
	end
	if FriendCircleIter ==4 then
		if x==NewFriendX+2 and y==NewFriendY then
			FriendCircleIter=5
			FriendCircleTimeout=0
		else 
			Move(MyID,NewFriendX+2,NewFriendY)
			FriendCircleTimeout=FriendCircleTimeout+1
			if FriendCircleTimeout>4 then
				FriendCircleIter=5
				FriendCircleTimeout=0
				TraceAI("giving up on cross step 4")	
			end
			return
		end
	end
	if FriendCircleIter == 5 then
		if x==NewFriendX-2 and y==NewFriendY then
			FriendCircleIter=0
			FriendCircleTimeout=0
			MyState=IDLE_ST
			TraceAI("Circle completed")
			return
		else 
			Move(MyID,NewFriendX-2,NewFriendY)
			FriendCircleTimeout=FriendCircleTimeout+1
			if FriendCircleTimeout>4 then
				FriendCircleIter=0
				FriendCircleTimeout=0
				MyState=IDLE_ST
				TraceAI("giving up on cross step 5")	
			end
			return
		end
	end
end

-------------------
--Command State Process
-------------------

function	OnMOVE_CMD_ST ()

	TraceAI ("OnMOVE_CMD_ST")

	local x, y = GetV (V_POSITION,MyID)
	if (x == MyMoveX and y == MyMoveY) then	
		if (MoveSticky == 1) then
			if (ReturnToMoveHold==0) then
				MyState = MOVE_CMD_HOLD_ST
				ReturnToMoveHold = 1
			else 
				ReturnToMoveHold = 0
				MyState = IDLE_ST
				return OnIDLE_ST()
			end
		else
			MyState=IDLE_ST
			return OnIDLE_ST()
		end
	elseif GetV(V_MOTION,MyID) == MOTION_STAND or MyDestX~=MyMoveX or MyDestY~=MyMoveY then
		MyDestX,MyDestY=MyMoveX,MyMoveY
		Move(MyID,MyDestX,MyDestY)
	end
end

function	OnMOVE_CMD_HOLD_ST ()
	
	TraceAI ("OnMOVE_CMD_HOLD_ST")
	MySkillUsedCount		= 0
	ChaseGiveUpCount		= 0
	AttackGiveUpCount		= 0
	ChaseDebuffUsed			= 0
	AttackDebuffUsed		= 0
	BypassKSProtect			= 0
	BerzerkMode			= 0
	if (DoIdleTasks()==nil) then
		return
	end
	if (MoveStickyFight==1 ) then
		local	object = SelectEnemy(GetFriendTargets())
		if (object ~= 0) then							-- MYOWNER_ATTACKED_IN
			MyState = CHASE_ST
			MyEnemy = object
			TraceAI ("MOVE_CMD_HOLD_ST -> CHASE_ST : MYOWNER_ATTACKED_IN")
			if (FastChangeCount < FastChangeLimit and FastChange_I2C ==1) then
				OnCHASE_ST()
			end
			return 
		end
		object = SelectEnemy(GetEnemyList(MyID,0))
		if (object ~= 0) then							-- ATTACKED_IN
			MyState = CHASE_ST
			MyEnemy = object
			TraceAI ("MOVE_CMD_HOLD_ST -> CHASE_ST : ATTACKED_IN")
			if (FastChangeCount < FastChangeLimit and FastChange_I2C ==1) then
				OnCHASE_ST()
			end
			return
		end
		object = SelectEnemy(GetEnemyList(MyID,-1))
		if (object ~= 0) then
			MyState = TANKCHASE_ST
			MyEnemy = object
			TraceAI ("MOVE_CMD_HOLD_ST -> TANKCHASE_ST")
			return
		end
	end
end


function OnSTOP_CMD_ST ()


end




function OnATTACK_OBJECT_CMD_ST ()

	

end


function OnATTACK_AREA_CMD_ST ()

	TraceAI ("OnATTACK_AREA_CMD_ST")

	local	object = GetOwnerEnemy (MyID)
	if (object == 0) then							
		object = GetMyEnemy (MyID) 
	end

	if (object ~= 0) then							-- MYOWNER_ATTACKED_IN or ATTACKED_IN
		MyState = CHASE_ST
		MyEnemy = object
		return
	end

	local x , y = GetV (V_POSITION,MyID)
	if (x == MyDestX and y == MyDestY) then			-- DESTARRIVED_IN
			MyState = IDLE_ST
	end

end




function OnPATROL_CMD_ST ()

	TraceAI ("OnPATROL_CMD_ST")

	local	object = GetOwnerEnemy (MyID)
	if (object == 0) then							
		object = GetMyEnemy (MyID) 
	end

	if (object ~= 0) then							-- MYOWNER_ATTACKED_IN or ATTACKED_IN
		MyState = CHASE_ST
		MyEnemy = object
		TraceAI ("PATROL_CMD_ST -> CHASE_ST : ATTACKED_IN")
		return
	end

	local x , y = GetV (V_POSITION,MyID)
	if (x == MyDestX and y == MyDestY) then			-- DESTARRIVED_IN
		MyDestX = MyPatrolX
		MyDestY = MyPatrolY
		MyPatrolX = x
		MyPatrolY = y
		Move (MyID,MyDestX,MyDestY)
	end

end


-----------------------------------------------------------------------
--IF ANYONE READING MY CODE HAS A FUCK'S CLUE WHAT THE HOLD COMMAND IS
--OR WHAT IN THE DEVIL IT'S PURPOSE IS, PLEASE ENLIGHTEN ME! -Azzy 
----------------------------------------------------------------------

function OnHOLD_CMD_ST () 

	TraceAI ("OnHOLD_CMD_ST")
	
	if (MyEnemy ~= 0) then
		local d = GetDistance(MyEnemy,MyID)
		if (d ~= -1 and d <= GetV(V_ATTACKRANGE,MyID)) then
				Attack (MyID,MyEnemy)
		else
			MyEnemy = 0
			EnemyPosX = {0,0,0,0,0,0,0,0,0,0}
			EnemyPosY = {0,0,0,0,0,0,0,0,0,0}
		end
		return
	end


	local	object = GetOwnerEnemy (MyID)
	if (object == 0) then							
		object = GetMyEnemy (MyID)
		if (object == 0) then						
			return
		end
	end

	MyEnemy = object

end




function OnSKILL_OBJECT_CMD_ST ()
	if IsInAttackSight(MyID,MyEnemy,MySkill,MySkillLevel) then
		DoSkill(MySkill,MySkillLevel,MyEnemy)
		MyState=IDLE_ST
		MyDestX,MyDestY,MyEnemy,MySkill,MySkillLevel=0,0,0,0,0
		return
	elseif SkillObjectCMDTimeout>SkillObjectCMDLimit then
		TraceAI("Couldn't get into range to use skill "..MySkill.." on "..MyEnemy)
		MyState=IDLE_ST
		MyDestX,MyDestY,MyEnemy,MySkill,MySkillLevel=0,0,0,0,0
		return OnIDLE_ST()
	else
		x,y=ClosestR(MyID,MyEnemy,AttackRange(MyID,MySkill,MySkillLevel),0)
		Move(MyID,x,y)
		SkillObjectCMDTimeout=SkillObjectCMDTimeout+1
		return
	end
	
	
end




function OnSKILL_AREA_CMD_ST ()

	TraceAI ("OnSKILL_AREA_CMD_ST")

	local x , y = GetV (V_POSITION,MyID)
	if (GetDistance(x,y,MyDestX,MyDestY) <= AttackRange(MyID,MySkill,MySkillLevel)) then	-- DESTARRIVED_IN
		SkillGround (MyID,MySkillLevel,MySkill,MyDestX,MyDestY)
		MyState = IDLE_ST
		MySkill = 0
	else
		x,y=Closer(MyID,MyDestX,MyDestY,MySkill)
	end

end







function OnFOLLOW_CMD_ST ()
	TraceAI ("OnFOLLOW_CMD_ST")
	local d = GetDistance2 (GetV(V_OWNER,MyID),MyID)
	if ( d > FollowStayBack) then
		BetterMoveToOwner (MyID,FollowStayBack)
		return
	end
	-- Start the friending process
	if (StandbyFriending == 1) then
		local actors = GetActors()
		for i,v in ipairs(actors) do
			if (IsMonster(v)~=1 and GetV(V_MOTION,GetV(V_OWNER,MyID))==MOTION_SIT) then
				TraceAI("Friend list modification")
				if (IsToRight(GetV(V_OWNER,MyID),v)==1) then
					if (MyFriends[v]==nil) then
						MyFriends[v] = 1
						FriendsFile = io.open("AI/USER_AI/A_Friends.lua", "w")
						FriendsFile:write (STRING_A_FRIENDS_HEAD)
						for k,v in pairs(MyFriends) do
							if (v==1) then
								FriendsFile:write ("MyFriends["..k.."]="..v.." -- \n")
							end
						end
						MyState=FRIEND_CIRCLE_ST
						ReturnToState=FOLLOW_CMD_ST
						NewFriendX,NewFriendY=GetV(V_POSITION,v)
						FriendsFile:close()
					end
				elseif (IsToRight(v,GetV(V_OWNER,MyID))==1) then
					if (MyFriends[v]~=nil) then
						MyFriends[v] = nil
						FriendsFile = io.open("AI/USER_AI/A_Friends.lua", "w")
						FriendsFile:write (STRING_A_FRIENDS_HEAD)
						for k,v in pairs(MyFriends) do
							if (v==1) then
								FriendsFile:write ("MyFriends["..k.."]="..v.." -- \n")
							end
						end
						MyState=FRIEND_CROSS_ST
						ReturnToState=FOLLOW_CMD_ST
						NewFriendX,NewFriendY=GetV(V_POSITION,v)
						FriendsFile:close()
					end
				end
			end
		end
        end
        -- Okay, that's done. 
        if (DefendStandby == 1) then
		local	object = SelectEnemy(GetFriendTargets())
		if (object ~= 0) then							-- MYOWNER_ATTACKED_IN
			MyState = CHASE_ST
			MyEnemy = object
			TraceAI ("FOLLOW_CMD_ST -> CHASE_ST : MYOWNER_ATTACKED_IN")
			if (FastChangeCount < FastChangeLimit and FastChange_I2C ==1) then
				OnCHASE_ST()
			end
			return 
		end
		object = SelectEnemy(GetEnemyList(MyID,0))
		if (object ~= 0) then							-- ATTACKED_IN
			MyState = CHASE_ST
			MyEnemy = object
			TraceAI ("FOLLOW_CMD_ST -> CHASE_ST : ATTACKED_IN ")
			if (FastChangeCount < FastChangeLimit and FastChange_I2C ==1) then
				OnCHASE_ST()
			end
			return
		end
	end
end


--#####################################
--### Targeting Routines start here ###
--#####################################
--[[
targets[actorid]=

MotionClass
-1 = Dead
0  = Stand
1  = Moving
2  = Flinch
3  = Attacking
4  = Skilling
5  = Casting
6  = Other

TargetClass
-2  = Non-friend player
-1  = Monster
0  = None
1  = Self
2  = Friend/Owner
]]--]]

function GetFriendTargets() -- returns list of targets of friends who are attacking
	local targets = {}
	for i,v in ipairs (GetActors()) do
		if (IsFriend(v) == 1) then
			motion=GetV(V_MOTION,v)
			target=GetV(V_TARGET,v)
			if (IsMonster(target)==1) then
				tact=GetTact(TACT_BASIC,target)
				if (FriendAttack[motion]==1 and tact > 0) then
					targets[target]={MotionClassLU[GetV(V_MOTION,target)],GetTargetClass(target),GetTact(TACT_BASIC,target),GetTact(TACT_CAST,target)}
					
				end
			end
		end
	end
	return targets
end
-- aggro arguments
-- 2 = snipe
-- 1 = aggro
-- 0 = nonaggro
-- -1 = tank
-- -2 = rescue


function	GetEnemyList (myid,aggro)
	local owner  = GetV(V_OWNER,myid)
	local enemys = {}
	if aggro==2 then
		sskill,slevel=GetSAtkSkill(MyID)
		oskill,olevel=GetAtkSkill(MyID)
	end
	TraceAI("GetEnemyList with aggro "..aggro)
	for k,v in pairs(Targets) do
		tact = GetTact(TACT_BASIC,k)
		casttact=GetTact(TACT_CAST,k)
		--TraceAI("Target"..k.." tact:"..tact.." Motion"..v[1].." TClass"..v[2])
		if (0 < tact and (tact < 5 or tact >9) and aggro==1 and (DoNotAttackMoving == 0 or v[1]~=1)) or (tact > 9 and aggro == 2 and k~=MyEnemy) or (v[2]>0 and tact~=-1 and (v[1]==3 or casttact == CAST_REACT) and aggro~=2 and (aggro > -1 or (aggro==-2 and IsRescueTarget(k)==1))) or (tact == -1 and aggro==-1 and v[2]~=1) then
			--TraceAI("Tactics say to attack:"..k)
			if (IsNotKS(myid,k)==1 and v[1] > -1) then
				--TraceAI("Is alive and not a KS")
				if aggro == 0 or (aggro~=2 and v[2]>0) then 
					if (GetMoveBounds() >= GetDistanceRect(owner,k)) then
						--TraceAI("Adding to target list: "..k)
						r={v[1],v[2],tact,casttact}
						enemys[k] = r
					--else 
					--	tempx,tempy=GetV(V_POSITION,owner)
					--	targx,targy=GetV(V_POSITION,k)
					--	TraceAI("target ignored "..k.." mypos "..tempx..","..tempy.." enemy "..targx..","..targy.." bounds "..GetMoveBounds().."dist "..GetDistanceRect(owner,k))
					end
				elseif aggro~=2 then
					if (GetAggroDist() >= GetDistanceA(owner,k)) then
						--TraceAI("Adding to target list: "..k)
						r={v[1],v[2],tact,casttact}
						enemys[k] = r
					end
				else -- Sniping - so we need to check range on skill, instead of aggrodist
					dist = GetDistanceA(MyID,k)
					tact_skill_class=(GetTact(TACT_SKILLCLASS,k))
					if sskill~=0 and tact_skill_class~=CLASS_OLD then
						if dist <= SkillInfo[sskill][2][slevel] then
							r={v[1],v[2],tact,casttact}
							enemys[k] = r
						end
					elseif oskill~=0 and tact_skill_class~=CLASS_S then
						if dist <= SkillInfo[oskill][2][olevel] then
							r={v[1],v[2],tact,casttact}
							enemys[k] = r
						end
					end
				end
			end
		end
	end
	return enemys
end

-- format of return
-- enemys[n][1] = Motion Class
-- enemys[n][2] = Target Class
-- enemys[n][3] = tact
-- enemys[n][4] = casttact

function SelectEnemy(enemys)
	local min_priority=-1
	local priority
	local min_dis = 100
	local dis
	--local min_aggro = -1
	--local aggro = 0
	local result=0
	local max_reachable=1
	--local min_mobcount=1
	--local mobcount=0
	for k,v in pairs(enemys) do
		basepriority = v[3] -- basic tact
		if basepriority > 9 then --Snipe modes are to be treated as attack
			basepriority = basepriority-8
		end
		if v[2]>0 and (v[1]==3 or v[4]==CAST_REACT) then
			aggro=1
		else
			aggro=0
		end
		if basepriority>6 and aggro==1 then
			priority=basepriority
		elseif basepriority==4 or basepriority==3 then
			priority=basepriority+1
			if aggro==0 then 
				priority=priority-2
			end
		elseif (priority==5 and aggro==1) then 
			priority=2
		elseif basepriority==2 then
			priority=1
		else
			priority=0
		end
		--TraceAI(k.." "..basepriority.." "..priority)
		--elseif ((priority==2 or priority==5) and (v[1]==3 or v[4]==CAST_REACT)) then
		--	aggro=-1
		--elseif then	
		--aggro = 1
		--else
		--	aggro=0
		--end
		dis = GetDistanceA (MyID,k)
		unreachable=Unreachable[k]
		if unreachable == nil then
			unreachable=0
		end
		
		--TraceAI(priority.."/"..min_priority.." "..dis.."/"..min_dis.." "..unreachable.."/"..max_reachable)
		if (unreachable <= max_reachable) then
			--if (aggro >= min_aggro) then
				if (priority > min_priority or (priority==min_priority and dis < min_dis)) then
					--if (dis < min_dis) then
						result = k
						min_dis = dis
						min_priority=priority
						--min_aggro=aggro
						max_reachable=unreachable
					--end
				end
			--end
		end
	end
	TraceAI("SelectEnemy returning target "..result)
	return result
end


--####################################################
--### DoIdleTasks - stuff done in any "idle" state ###
--### like buffs and command processing            ###
--####################################################

function DoIdleTasks()
	local cmd = List.popleft(ResCmdList)
	if (cmd ~= nil) then		
		ProcessCommand (cmd)	--  ɾ ó 
		return 
	end
	if OnIdleTasks()==1 then
		return
	end
	if GetTick() > AutoSkillTimeout then
		if UseAutoHeal==2 then
			DoHealingTasks(MyID)
		end
		if (UseAutoQuicken == 1 and QuickenTimeout ~=-1) then
			if (GetTick() > QuickenTimeout) then
				local skill,level = GetQuickenSkill(MyID)
				if (skill==0) then
					QuickenTimeout = -1
				elseif (SkillInfo[skill][3][level] <= GetV(V_SP,MyID)) then
					DoSkill(skill,level,MyID)
					QuickenTimeout = GetTick() + SkillInfo[skill][8][level]
					UpdateTimeoutFile()
					TraceAI("Using quicken skill "..FormatSkill(skill,level))
					return
				end
			end
		end
		if (UseAutoGuard == 1 and GuardTimeout ~=-1) then
			if (GetTick() > GuardTimeout) then
				local skill,level = GetGuardSkill(MyID)
				if (skill <= 0) then
					GuardTimeout = -1
				elseif (SkillInfo[skill][3][level] <= GetV(V_SP,MyID) and (skill~=HAMI_BULWARK or UseAutoQuicken==0 or GetV(V_SP,MyID) > 120)) then
					DoSkill(skill,level,MyID)
					GuardTimeout = GetTick() + SkillInfo[skill][8][level]
					UpdateTimeoutFile()
					TraceAI("Using guard skill "..FormatSkill(skill,level))
					return
				end
			end
		end
		if SOffensiveTimeout ~=-1 then
			if (GetTick() > SOffensiveTimeout) then
				local skill,level = GetSOffensiveSkill(MyID)
				if (skill <= 0) then
					SOffensiveTimeout = -1
				elseif (SkillInfo[skill][3][level] <= GetV(V_SP,MyID)) then
					DoSkill(skill,level,MyID)
					SOffensiveTimeout = GetTick() + SkillInfo[skill][8][level]		
					UpdateTimeoutFile()
					TraceAI("Using offensive homun S buff "..FormatSkill(skill,level))
					return
				end
			end
		end
		if SDefensiveTimeout ~=-1 then
			if (GetTick() > SDefensiveTimeout) then
				local skill,level = GetSDefensiveSkill(MyID)
				if (skill <= 0) then
					SDefensiveTimeout = -1
				elseif (SkillInfo[skill][3][level] <= GetV(V_SP,MyID)) then
					DoSkill(skill,level,MyID)
					SDefensiveTimeout = GetTick() + SkillInfo[skill][8][level]
					UpdateTimeoutFile()
					TraceAI("Using defensive homun S buff "..FormatSkill(skill,level))
					return
				end
			end
		end
		if SOwnerBuffTimeout ~=-1 then
			if (GetTick() > SOwnerBuffTimeout) then
				local skill,level = GetSOwnerBuffSkill(MyID)
				if (skill <= 0) then
					SOwnerBuffTimeout = -1
				elseif (SkillInfo[skill][3][level] <= GetV(V_SP,MyID)) then
					DoSkill(skill,level,MyID)
					SOwnerBuffTimeout = GetTick() + SkillInfo[skill][8][level]
					UpdateTimeoutFile()
					TraceAI("Using owner-buffing homun S skill "..FormatSkill(skill,level))
					return
				end
			end
		end
		if (UseAutoMag == 1 and MagTimeout ~=-1) then
			if (GetTick() > MagTimeout) then
				if (GetV(V_MERTYPE,MyID)~=4) then
					MagTimeout = -1
				elseif (40 <= GetV(V_SP,MyID)) then
					SkillObject(MyID,1,MER_MAGNIFICAT,MyID)
					MagTimeout = GetTick() + 34000
					TraceAI("Using magnificat skill "..FormatSkill(skill,level))
					UpdateTimeoutFile()
					return
				end
			end
		end
		if (UseAutoSight == 1 and SightTimeout~=-1) then
			if (GetTick() > SightTimeout and IsHiddenOnScreen(MyID) == 1) then
				if (GetV(V_MERTYPE,MyID) ~= 2) then
					SightTimeout = -1
				elseif (10 <= GetV(V_SP,MyID)) then
					SkillObject(MyID,1,MER_SIGHT,MyID)
					SightTimeout = GetTick() + 10000
					TraceAI("Using sight skill "..FormatSkill(skill,level))
					return
				end
			end
		end
		
		if (UseProvokeOwner == 1 and ProvokeOwnerTimeout ~=-1) then
			if (GetTick() > ProvokeOwnerTimeout) then
				local skill,level= GetProvokeSkill(MyID)
				if (skill <= 0) then
					ProvokeOwnerTimeout = -1
				elseif (SkillInfo[skill][3][level] <= GetV(V_SP,MyID) and GetTick() > AutoSkillTimeout) then
					MyState = PROVOKE_ST
					MyEnemy = GetV(V_OWNER,MyID)
					MySkill = skill
					MySkillLevel = level
					TraceAI("IDLE_ST -> PROVOKE_ST: Using provoke skill "..SkillInfo[MySkill][1].." on owner")
					return OnPROVOKE_ST()
				end
			end
		end
		if (UseProvokeSelf == 1 and ProvokeSelfTimeout ~=-1) then
				if (GetTick() > ProvokeSelfTimeout) then
					local skill,level = GetProvokeSkill(MyID)
					if (skill <= 0) then
						ProvokeSelfTimeout = -1
					elseif (SkillInfo[skill][3][level] <= GetV(V_SP,MyID)) then
						--MyState=PROVOKE_ST
						--OnPROVOKE_ST()
						--return
						DoSkill(skill,level,MyID)
						ProvokeSelfTimeout = GetTick()+SkillInfo[skill][8][level]
						return
					end
				end
		end
		if (UseSacrificeOwner == 1 and SacrificeTimeout ~=-1) then
			if (GetTick() > SacrificeTimeout) then
				local skill,level= GetSacrificeSkill(MyID)
				if (skill <= 0) then
					SacrificeTimeout = -1
				elseif (SkillInfo[skill][3][level] <= GetV(V_SP,MyID)) then
					DoSkill(skill,level,GetV(V_OWNER,MyID))
					SacrificeTimeout = GetTick() + SkillInfo[skill][8][level] -- this will recast it before it drops, because the countdown starts at the start of the cast time, but duration counts down from end of cast time.
					TraceAI("Using sacrifice skill "..FormatSkill(skill,level))
					return
				end
			end
		end
	end
	if (GetV(V_MOTION,GetV(V_OWNER,MyID))==MOTION_SIT and MyState~=REST_ST and DoNotUseRest~=1) then
		MyState=REST_ST
		TraceAI("DoIdleTasks - Owner sitting, MyState -> REST_ST")
		return
	end
	return 1
end

function DoHealingTasks (myid) 
	rhp=HPPercent(myid)
	ohp=HPPercent(GetV(V_OWNER,myid))
	skill,level=GetHealingSkill(myid)
	if skill==0 then 
		UseAutoHeal=0
		return
	elseif level==0 or GetTick() < AutoSkillTimeout then
		return --skill in cooldown
	end
	if rhp < HealHomunHP then
		if skill==HVAN_CHAOTIC then
			if GetV(V_SP,myid) > SkillInfo[skill][3][level] then
				TraceAI("Using self Healing skill "..FormatSkill(skill,level))
				DoSkill(skill,4,myid)
			else
				TraceAI("Can't use self healing skill, no SP")
			end
		end
	end
	if ohp < HealOwnerHP then
		if GetV(V_SP,myid) > SkillInfo[skill][3][level] then
			TraceAI("Using Healing skill "..FormatSkill(skill,level))
			DoSkill(skill,level,GetV(V_OWNER,myid))
		else
			TraceAI("Can't use healing skill, no SP")
		end
	end
end

function UpdateTimeoutFile()
	if StickyStandby==2 then
		ShouldStandbyx=ShouldStandby
	else
		ShouldStandbyx=0
	end
	if IsHomun(MyID)==1 then
		OutFile=io.open("AI/USER_AI/H_SkillTimeouts.lua","w")
	else
		OutFile=io.open("AI/USER_AI/M_SkillTimeouts.lua","w")
	end
	if OutFile~=nil then
		OutFile:write("MagTimeout="..TimeoutConv(MagTimeout).."\nSOffensiveTimeout="..TimeoutConv(SOffensiveTimeout).."\nSDefensiveTimeout="..TimeoutConv(SDefensiveTimeout).."\nSOwnerBuffTimeout="..TimeoutConv(SOwnerBuffTimeout).."\nGuardTimeout="..TimeoutConv(GuardTimeout).."\nQuickenTimeout="..TimeoutConv(QuickenTimeout).."\nShouldStandby="..ShouldStandbyx)
		OutFile:close()
	else
		TraceAI("Failed to update timeout file")
		logappend("AAI_ERROR","Failed to update timeout file")
	end
	return
end

function TimeoutConv(a)
	if a==-1 then
		return 0
	else
		return a
	end
end

function OnPROVOKE_ST()
	--local skill,level = GetProvokeSkill(MyID)
	if IsInAttackSight(MyID,MyEnemy,MySkill,MySkillLevel) then
		DoSkill(MySkill,MySkillLevel,MyEnemy)
		ProvokeOwnerTimeout = GetTick()+SkillInfo[MySkill][8][MySkillLevel]
		MyState=IDLE_ST
		TraceAI("PROVOKE_ST -> IDLE_ST - provoked okay")
		MyDestX,MyDestY,MyEnemy,MySkill,MySkillLevel=0,0,0,0,0
		return
	elseif SkillObjectCMDTimeout>SkillObjectCMDLimit then
		TraceAI("PROVOKE_ST -> IDLE_ST Couldn't get into range to provoke owner")
		MyState=IDLE_ST
		MyDestX,MyDestY,MyEnemy,MySkill,MySkillLevel=0,0,0,0,0
		return OnIDLE_ST()
	else
		x,y=ClosestR(MyID,MyEnemy,AttackRange(MyID,MySkill,MySkillLevel),0)
		Move(MyID,x,y)
		SkillObjectCMDTimeout=SkillObjectCMDTimeout+1
		return
	end
	
	
end


--#########################
--### Random Move Stuff ###
--### Yes, it's ugly.	###
--#########################

function	OnRANDWALK_ST ()

	TraceAI ("OnRANDWALK_ST")
	RandWalkTries = RandWalkTries + 1
	local x, y = GetV (V_POSITION,MyID)
	local mymotion = GetV(V_MOTION,MyID)
	if (x == MyDestX and y == MyDestY) then				-- DESTINATION_ARRIVED_IN
		MyState = IDLE_ST
	elseif (RandWalkTries > 2 and mymotion==MOTION_STAND) then
		MyDestX=0
		MyDestY=0
		MyState= IDLE_ST
	end
end

function	DoRandomMove()
	TraceAI ("Random Move Called")
	DoRand=0
	local x, y = GetV(V_POSITION,MyID)
	if (UseRouteWalk==1) then
		destx,desty,step=GetRouteNext(x,y,RouteWalkStep)
		if RouteWalkStep==nil then
			RouteWalkStepx="nil"
		end
		if step==nil then
					stepx="nil"
		end
		TraceAI("GetRouteNext returned "..destx..","..desty..","..stepx.." from "..x..","..y..","..RouteWalkStepx)
		if (x~=destx or y~=desty) then --it will return x,y=destx,desty if it cant find a place to move
			DoRand=1
			MyDestX,MyDestY=destx,desty
			RouteWalkStep=step
		else
			MyDestx,MyDestY=0,0
		end
	end
	if (UseRandWalk==1 and MyDestX==0 and MyDestY==0) then
		local xsign=2*math.random(0,1)-1
		local ysign=2*math.random(0,1)-1
		MyDestX=x+math.random(6,9)*xsign
		MyDestY=y+math.random(6,9)*ysign
		DoRand=1
	end
	if (DoRand==1) then
		Move(MyID,MyDestX,MyDestY)
		RandWalkTries=0
		MyState=RANDWALK_ST
	end
	return
end

function GetRouteNext(x,y,step)
	routelength=len(MyRoute)
	TraceAI("Route Length" ..routelength)
	if (step~=nil) then
		if ((routelength <= step and RouteWalkDirection == 1) or (step <= 1 and RouteWalkDirection==-1)) then 
			TraceAI("RouteWalk: At end of route, acting appropriately")
			if (RouteWalkCircle==1) then
				if (RouteWalkDirection ==1) then
					nextstep=1
				else
					nextstep=len(MyRoute)
				end
			else
				RouteWalkDirection = -1*RouteWalkDirection
				nextstep=step
			end
		else
			nextstep=step+RouteWalkDirection
		end
		TraceAI("RouteWalk: "..nextstep.."step:"..step.." "..len(MyRoute))
		nx,ny=MyRoute[nextstep][1],MyRoute[nextstep][2]
		dist2n=GetDistance(x,y,nx,ny)
		if (dist2n>10) then
			nx,ny=MyRoute[step][1],MyRoute[step][2]
			dist2n=GetDistance(x,y,nx,ny)
			if (dist2n>10) then
				step=nil
			end
		else
			step=nextstep
		end
	end
	if (step~=nil) then
		return nx,ny,step
	else
		for k,v in pairs(MyRoute) do
			if (GetDistance(x,y,v[1],v[2]) < 10) then
				return v[1],v[2],k
			end
		end
		return x,y,nil
	end
end

--##############################
--### My orbitwalk routine   ###
--### sucks. I know.         ###
--### Is not current priority###
--##############################

function	OnORBITWALK_ST()
	TraceAI ("OnORBITWALK_ST")
	if (DoIdleTasks()==nil) then
		return
	end
	if SuperPassive~=1 then
		local	object = SelectEnemy(GetFriendTargets())
		if (object ~= 0) then							-- MYOWNER_ATTACKED_IN
			MyState = CHASE_ST
			MyEnemy = object
			TraceAI ("IDLE_ST -> CHASE_ST : MYOWNER_ATTACKED_IN")
			if (FastChangeCount < FastChangeLimit and FastChange_I2C ==1) then
				OnCHASE_ST()
			end
			return 
		end
		if (HPPercent(MyID) > AggroHP and SPPercent(MyID) > AggroSP) then
			aggro=1
		else
			aggro=0
		end
		object=SelectEnemy(GetEnemyList(MyID,aggro))
		if object~=0 then
			MyState = CHASE_ST
			MyEnemy = object
			TraceAI ("IDLE_ST -> CHASE_ST : ATTACKED_IN")
			if (FastChangeCount < FastChangeLimit and FastChange_I2C ==1) then
				OnCHASE_ST()
			end
			return	
		end
		if (aggro==1 and TankMonsterCount < TankMonsterLimit) then
			object = SelectEnemy(GetEnemyList(MyID,-1))
			if (object ~= 0) then
				MyState = TANKCHASE_ST
				MyEnemy = object
				TraceAI ("IDLE_ST -> TANKCHASE_ST")
				return
			end
		end
	end
	local distance = GetDistanceFromOwner(MyID)
	if ( distance > UseOrbitWalk+2 or distance == -1) then		-- MYOWNER_OUTSIGNT_IN
		MyState = FOLLOW_ST
		TraceAI ("ORBITWALK_ST -> FOLLOW_ST")
		return
	end
	if (HPPercent(MyID)~=100 or SPPercent(MyID)~=100) then
		MyState = IDLE_ST
		TraceAI ("Low HP/SP, returning to idle state")
		return
	end
	local x, y = GetV (V_POSITION,MyID)
	local mymotion = GetV(V_MOTION,MyID)
	if (mymotion==MOTION_STAND) then
		if (x==MyDestX and y==MyDestY or OrbitWalkTries > 6) then
			if (OrbitWalkStep == 7) then
				OrbitWalkStep=0
			else
				OrbitWalkStep=OrbitWalkStep+1
			end
			OrbitWalkTries = 0
			local ownerx, ownery=GetV(V_POSITION,GetV(V_OWNER,MyID))
			local offx, offy = GetOrbitNext(UseOrbitWalk,OrbitWalkStep)
			MyDestX=ownerx+offx
			MyDestY=ownery+offy
			Move(MyID,MyDestX,MyDestY)
		else
			OrbitWalkTries = OrbitWalkTries +1
			Move(MyID,MyDestX,MyDestY)
		end
		return
	end	
end

function GetOrbitNext(distance,step)
	local angle=math.rad(step*45)
	local destx=math.ceil(math.sin(angle)*distance)
	local desty=math.ceil(math.cos(angle)*distance)
	TraceAI("OrbitDestOffs: "..destx..","..desty) 
	return destx,desty
end


--######################
--### DoAutoPushback ###
--######################

function DoAutoPushback(myid)
	local actors = GetActors()
	local x,y=GetV(V_POSITION,myid)
	for i,v in ipairs(actors) do
		if (IsMonster(v)==1) then
			local tact= GetTact(TACT_PUSHBACK,v)
			local target =GetV(V_TARGET,v)
			if (tact==2 or (tact==1 and IsFriendOrSelf(target)==1))then				
				TraceAI("Pushback: "..GetDistance2(target,v))
				if (GetDistance2(target,v) <= AutoPushbackThreshold and GetDistance2(target,v)~=-1) then
					TraceAI("Enemies close to me, using pushback")
					local skill,level=GetPushbackSkill(MyID)
					if (skill==0) then
						UseAutoPushback=0
					elseif (GetV(V_SP,myid) >= SkillInfo[skill][3][level] and GetV(V_SKILLATTACKRANGE,MyID,skill) >= GetDistance2(myid,v)) then
						DoSkill(skill,level,v)
						return
					end
					break
				end
			end
		elseif (IsFriendOrSelf(id)==0 and PVPmode ~=0) then
			local tact= GetPVPTact(TACT_PUSHBACK,v)
			local target =GetV(V_TARGET,v)
			if (tact==2 or (tact==1 and IsFriendOrSelf(target)==1))then
				if (GetDistance2(target,v) <= AutoPushbackThreshold) then
					TraceAI("Enemies close to me, using pushback")
					local skill,level=GetPushbackSkill(MyID)
					if (skill==0) then
						UseAutoPushback=0
					elseif (GetV(V_SP,myid) >= SkillInfo[skill][3][level]) then
						DoSkill(skill,level,v)
						return
					end
					break
				end
			end
		end
	end
	return 1
end


--####################
--### DoKiteAdjust ###
--####################

function DoKiteAdjust(myid,enemy)
	local step
	local target=GetV(V_TARGET,enemy)
	if (IsFriend(target)==1 or target==MyID) then
		step=KiteStep
	else
		step=KiteParanoidStep
	end
	local x,y=GetV(V_POSITION,myid)
	local ox,oy=GetV(V_POSITION,GetV(V_OWNER,myid))
	local ex,ey=GetV(V_POSITION,enemy)
	local xoptions ={[2]=1,[0]=1,[1]=1}
	local yoptions ={[2]=1,[0]=1,[1]=1}
	local xdirection,ydirection=0,0
	if (x > ex) then
		xoptions[2]=0
	elseif (x < ex) then
		xoptions[1]=0
	else
		yoptions[0]=0
	end
	if (y > ey) then
		yoptions[2]=0
	elseif (y < ey) then
		yoptions[1]=0
	else
		xoptions[0]=0
	end
	if (ox > x) then
		if (xoptions[1]==1) then
			xdirection=1
		elseif (xoptions[0]==1) then
			xdirection=0
		elseif (xoptions[2]==1 and (ox-x+step) <= KiteBounds) then
			xdirection=-1
		elseif	(ey < y) then
			xdirection=0
		else
			xdirection=1
		end
	else
		if (xoptions[2]==1) then
			xdirection=-1
		elseif (xoptions[0]==1) then
			xdirection=0
		elseif (xoptions[1]==1 and (x-ox+step) <= KiteBounds) then
			xdirection=1
		elseif	(ey > y) then
			xdirection=0
		else
			xdirection=-1
		end
	end
	if (oy > y) then
		if (yoptions[1]==1) then
			ydirection=1
		elseif (yoptions[0]==1 and xdirection~=0) then
			ydirection=0
		elseif (yoptions[2]==1 and oy-y+step <= step) then
			ydirection=-1
		elseif	(ex > x and xdirection~=0) then
			ydirection=0
		else
			ydirection=1
		end
	else 
		if (yoptions[2]==1) then
			ydirection=-1
		elseif (yoptions[0]==1 and xdirection~=0) then
			ydirection=0
		elseif (yoptions[1]==1 and y-oy+step <= KiteBounds) then
			ydirection=1
		elseif	(ex < x and xdirection~=0) then
			ydirection=0
		else
			ydirection=-1
		end
	end
	TraceAI("Kiteing in "..xdirection..","..ydirection.." direction")
	MyDestX=x+step*xdirection
	MyDestY=y+step*ydirection
	Move(myid,MyDestX,MyDestY)
end

--########################
--### Main AI Function ###
--########################

function AI(myid)
	MyID = myid
	if LastAITime==GetTick() then --prevent AI from running twice in the same tick. 
		TraceAI("double-AI() call detected, blocked")
		return
	else
		if LastAITime + 500 < GetTick() then
			TraceAI("Missed AI calls. Previous AI call was "..LastAITime-GetTick().." ms ago")
		end
		LastAITime=GetTick()
	end
	if DoneInit== 0 then
		doInit(myid)
	end
	OnAIstart()
	-- ###AUTOFRIEND###
	-- Save the ID to a file so counterpart can friend it
	-- Why is it here instead of at the start?
	-- Because the client wont tell us our ID until AI() is called :-(
	if (NeedToDoAutoFriend==1 and NewAutoFriend==1) then
		TraceAI("Now it's time to do the autofriend")
		if (IsHomun(myid)==1) then
			OutFile=io.open("AI/USER_AI/H_ID.txt","w")
		else
			OutFile=io.open("AI/USER_AI/M_ID.txt","w")
		end
		OutFile:write (myid)
		OutFile:close()
		NeedToDoAutoFriend=0
	end
	
	--###BOOKKEEPING###
	if (MercType == 0 and IsHomun(myid) == 0) then -- if the fucking stupid devs made GetV(V_MERTYPE,id) work i wouldnt need this!
		MercType=GetMerType(myid)
	end
	
	-- Hackjob to fix strange behavior, with the timeouts being set to hours, days, or weeks in the future (suspect due to GetTick() returning bad numbers). 
	if GuardTimeout-GetTick() > 350000 then
		GuardTimeout=GetTick()+300000
	end
	if MagTimeout-GetTick() > 350000 then
			MagTimeout=GetTick()+300000
	end
	if QuickenTimeout-GetTick() > 350000 then
		QuickenTimeout=GetTick()+300000
	end
	
	FastChangeCount = 0
	--###DATA GATHERING###
	for k,v in pairs(Unreachable) do
		if (IsOutOfSight(myid,k)==true or GetV(V_MOTION,k)==MOTION_DEAD or (IsFriendOrSelf(GetV(V_TARGET,k))==1) and GetV(V_MOTION,k)~=MOTION_STAND) then
			Unreachable[k]=nil
			TraceAI("Marking as reachable"..k)
		end
	end
	
	-- Position sensing
	x,y=GetV(V_POSITION,MyID)
	ox,oy=GetV(V_POSITION,GetV(V_OWNER,MyID))
	if MyEnemy ~= 0 then
		ex,ey=GetV(V_POSITION,MyEnemy)
	else
		ex,ey=0,0
	end
	for v=10,2,-1 do
		MyPosX[v],MyPosY[v],OwnerPosX[v],OwnerPosY[v],EnemyPosX[v],EnemyPosY[v],MyMotions[v],MyStates[v]=MyPosX[v-1],MyPosY[v-1],OwnerPosX[v-1],OwnerPosY[v-1],EnemyPosX[v-1],EnemyPosY[v-1],MyMotions[v-1],MyStates[v-1]
	end
	MyPosX[1],MyPosY[1],OwnerPosX[1],OwnerPosY[1],EnemyPosX[1],EnemyPosY[1],MyMotions[1],MyStates[1]=x,y,ox,oy,ex,ey,GetV(V_MOTION,MyID),MyState
	-- Actor list preprocessing
	local actors=GetActors()
	Actors={}
	Players={}
	Monsters={}
	Summons={}
	Retainers={}
	Targets={}
	TankMonsterCount=0
	for i,v in ipairs(actors) do
		if (false == IsOutOfSight(myid,v)) then
			Actors[v]=1
			if (v > MagicNumber2) then
				Players[v]=1
			
			elseif IsMonster(v)==1 then
				Monsters[v]=1
				if (v < MagicNumber) then
					Summons[v]=1
				end
				if (AutoDetectPlant==1 and IsActive[v]~=1) then
					if (GetV(V_MOTION,v)==MOTION_STAND or GetV(V_MOTION,v)==MOTION_DAMAGE or GetV(V_MOTION,v)==MOTION_DEAD) then
						IsActive[v]=0
					else
						IsActive[v]=1
					end
				end
				if (GetTact(TACT_BASIC,v)==TACT_TANK and GetV(V_TARGET,v)==MyID) then
					TankMonsterCount=TankMonsterCount+1
				end
				motionclass=MotionClassLU[GetV(V_MOTION,v)]
				if motionclass==nil then 
					motionclass=3 
				end --CHANGE
				if (motionclass~=-1 and (v > MagicNumber or IsActive[v]==1)) then 
					Targets[v]={motionclass,GetTargetClass(GetV(V_TARGET,v))}
				end
			elseif (v < MagicNumber) then		
				Retainers[v]=1
			end
		end
	end
	if PVPmode==1 then
		for k,v in Players do
			--if IsMonster(v)==1 then
			if IsPVPFriend(k) then
				--Targets[k] = {MotionClassLU[GetV(V_MOTION,v)],GetTargetClass(GetV(V_TARGET,v))}
				--More testing needed
			end
		end
	end
	
	--New autofriend routine
	if (NewAutoFriend==1 and AssumeHomun==1) then
		friendedOK=0
		retainercount=0
		for k,v in pairs(Retainers) do
			if (k~=MyID) then
				retainercount=retainercount+1
				if (MyFriends[k]==2) then
					friendedOK=1
				end
			end
		end
		if (friendedOK==0) then
			if (IsHomun(myid)==1) then
				InFile=io.open("AI/USER_AI/M_ID.txt","r")
			else
				InFile=io.open("AI/USER_AI/H_ID.txt","r")
			end
			if InFile~=nil then
				retainerid=InFile:read("*a")
				InFile:close()
				retainerid=tonumber(retainerid)
				if (retainerid ~=nil) then
					MyFriends[retainerid]=2
				end
			end
		end
	end

	--###COMMAND PROCESSING###
	local msg	= GetMsg (myid)			-- command
	local rmsg	= GetResMsg (myid)		-- reserved command
	
	if msg[1] == NONE_CMD then
		if rmsg[1] ~= NONE_CMD then
			if List.size(ResCmdList) < 10 then
				List.pushright (ResCmdList,rmsg)
			end
		end
	else
		List.clear (ResCmdList)	-- ο  ԷµǸ  ɵ Ѵ.  
		ProcessCommand (msg)	-- ɾ ó 
	end
	
	
	OnAImiddle()
	
	--###EMERGENCY HANDLING###
	
	-- Avoid Routine
	if (IsHomun(MyID)==1 and UseAvoid==1) then
		for i,v in ipairs(actors) do
			if MyAvoid[GetV(V_HOMUNTYPE,v)]==1 then
				os.exit()
			end
		end
	end
	if UseAutoHeal==1 then
		DoHealingTasks(MyID)
	end
	
	-- Prevent from being left behind
	-- Used only in critical (merc out of MoveBounds) situations
	-- Otherwise, IDLE_ST handles it
	
	local dist2owner=GetDistanceRect(MyID,GetV(V_OWNER,MyID))
	if (MyState ~=FOLLOW_ST and dist2owner > GetMoveBounds()) then
		MyState=FOLLOW_ST
	end
	--Cancel all action during the spawn invulnerability
	if (GetTick() < (MyStart + SpawnDelay)) then
		return
	end
	
	object = SelectEnemy(GetEnemyList(MyID,-2))
	if (object~=0 and object ~= MyEnemy and MyState~=FOLLOW_ST) then
		MyEnemy=object
		MyState=CHASE_ST
		TraceAI("RESCUE ACTIVATED - Targeting "..object)
	end
	
	-- Check to see if mercenary should activate kiting routine
	if ((KiteMonsters==1 and (KiteOK(MyID)==1 or ForceKite == 1)) or HPPercent(MyID) < FleeHP) then
		local x,y=GetV(V_POSITION,MyID)
		if ((x==KiteDestX and y==KiteDestY) or (KiteDestX==0 and KiteDestY==0)) then
			local actors = GetActors()
			kitecalled=0
			for i,v in ipairs(actors) do
				if (IsMonster(v)==1 and GetV(V_MOTION,v) ~= MOTION_DEAD) then
					local target=GetV(V_TARGET,v)
					local tact = GetTact(TACT_KITE,v)
					if ((IsFriendOrSelf(target)==1 and tact==1) or tact==2) then
						local threshold
						if (IsFriend(target)==1 or target==MyID) then
							threshold=KiteThreshold
						else
							threshold=KiteParanoidThreshold
						end
						if (GetDistance2(MyID,v) <= threshold) then
							TraceAI("Enemies close to me, start kite routine. ")
							DoKiteAdjust(MyID,v)
							kitecalled=1
							break
						end
					end
				end
			end
			if (kitecalled == 0) then
				KiteDestX,KiteDestY=0,0
			end
		else
			Move(myid,KiteDestX,KiteDestY)
		end
	end 
	
	--###STATE PROCESSES###
 	if (MyState == IDLE_ST) then
		OnIDLE_ST ()
	elseif (MyState == CHASE_ST) then					
		OnCHASE_ST ()
	elseif (MyState == ATTACK_ST) then
		OnATTACK_ST ()
	elseif (MyState == FOLLOW_ST) then
		OnFOLLOW_ST ()
	elseif (MyState == MOVE_CMD_ST) then
		OnMOVE_CMD_ST ()
	elseif (MyState == STOP_CMD_ST) then
		OnSTOP_CMD_ST ()
	elseif (MyState == ATTACK_OBJECT_CMD_ST) then
		OnATTACK_OBJECT_CMD_ST ()
	elseif (MyState == ATTACK_AREA_CMD_ST) then
		OnATTACK_AREA_CMD_ST ()
	elseif (MyState == PATROL_CMD_ST) then
		OnPATROL_CMD_ST ()
	elseif (MyState == HOLD_CMD_ST) then
		OnHOLD_CMD_ST ()
	elseif (MyState == SKILL_OBJECT_CMD_ST) then
		OnSKILL_OBJECT_CMD_ST ()
	elseif (MyState == SKILL_AREA_CMD_ST) then
		OnSKILL_AREA_CMD_ST ()
	elseif (MyState == FOLLOW_CMD_ST) then
		OnFOLLOW_CMD_ST ()
	elseif (MyState == RANDWALK_ST) then
		OnRANDWALK_ST ()
	elseif (MyState == ORBITWALK_ST) then
		OnORBITWALK_ST()
	elseif (MyState == REST_ST) then
		OnREST_ST()
	elseif (MyState == TANKCHASE_ST) then
		OnTANKCHASE_ST()
	elseif (MyState == TANK_ST) then
		OnTANK_ST()
	elseif (MyState == PROVOKE_ST) then
		OnPROVOKE_ST()
	elseif (MyState == MOVE_CMD_HOLD_ST) then
		OnMOVE_CMD_HOLD_ST()
	elseif (MyState == FRIEND_CROSS_ST) then
		OnFRIEND_CROSS_ST()
	elseif (MyState == FRIEND_CIRCLE_ST) then
		OnFRIEND_CIRCLE_ST()
	else
		if NewState(MyState)==-1 then  
			TraceAI("Invalid State: "..MyState.." -> IDLE_ST")
			logappend("AAI_ERROR","MyState set to invalid state: "..MyState)
			MyState=IDLE_ST
		end
	end
end